--------------------------------------------------------------------------------
--                 		L O C A L I Z A T I O N  F I L E      		          --
--------------------------------------------------------------------------------
--						English / United States (default)					  --
--------------------------------------------------------------------------------
-- 				Maintained By Dylan Fortune (http://dylanfortune.com)		  --
--------------------------------------------------------------------------------
--   A localization file contains a single dictionary that populates a table  --
--------------------------------------------------------------------------------
-- 		        This script is called directly after the Core.lua file. 	  --
--------------------------------------------------------------------------------
AllTheThings.Locales.enUS = {
	-- General Text
	["TITLE"] = "ALL THE THINGS";
	["DESCRIPTION"] = "\"Foolishly you have sought your own demise. Brazenly you have disregarded powers beyond your understanding. You have fought hard to invade the realm of the Collector. Now there is only one way out - To walk the lonely path... of the damned.\"";
	["LOADING"] = "v%s loaded successfully.";
	["TITLE_OPTIONS"] = "All the Things";
	["FILTERS"] = "Filters";
	["PREFERENCES"] = "Preferences";
	
	-- Minimap Icon Text
	["MINIMAP_MOUSEOVER_TEXT"] = "Left click + drag to move.\nRight click for options.";
	
	-- Frame Text
	["LIST_FRAME_TITLE"] = "ITEM COLLECTION";
	["REFRESH_BUTTON_TITLE"] = "REFRESH THE THINGS";
	["CONGRATULATIONS"] = "CONGRATULATIONS! You did it!";
	["INSTRUCTIONS"] = "Looks like something terrible has happened. Reinstall the addon!";
	
	-- Group Text
	["DUNGEONS&RAIDS"] = "Dungeons & Raids";
	["MISCELLANEOUS"] = "Miscellaneous";
	
	-- Error Text
	["ERROR_UNKNOWN"] = "An unknown error occured.";
	
	["ITEM_ID_ADDED"] = "%s (%d) was added to your collection.";
	["ITEM_ID_ADDED_SHARED"] = "%s (%d) [+%d] were added to your collection.";
	["ITEM_ID_REMOVED"] = "%s (%d) was removed from your collection.";
	["ITEM_ID_REMOVED_SHARED"] = "%s (%d) [+%d] were removed from your collection.";
	
	-- Tooltip Text
	["LEFT_CLICK_TO_EXPAND"] = "|cff3399ffLeft Click to Expand/Collapse|r";
	["LEFT_CLICK_TO_MOVE"] = "|cff3399ffLeft Click and Drag to Move|r";
	["SHIFT_LEFT_CLICK"] = "|cff3399ffShift + Click to Refresh Collections|r";
	["RIGHT_CLICK_TO_CONFIGURE"] = "|cff3399ffRight Click to Configure Filters|r";
	["RIGHT_CLICK_TO_POPOUT"] = "|cff3399ffRight Click to Pop Out to Mini List|r";
	["ACHIEVEMENT"] = "Achievement";
	["ACHIEVEMENT_ID"] = "Achievement ID";
	["DIFFICULTY"] = "Difficulty";
	["DIFFICULTY_ID"] = "Difficulty ID";
	["ENCOUNTER"] = "Encounter";
	["ENCOUNTER_ID"] = "Encounter ID";
	["EXPANSION"] = "Expansion";
	["EXPANSION_ID"] = "Expansion ID";
	["FILTER"] = "Filter";
	["FILTER_ID"] = "Filter ID";
	["INSTANCE"] = "Instance";
	["INSTANCE_ID"] = "Instance ID";
	["DUNGEON"] = "Dungeon";
	["RAID"] = "Raid";
	["HISTORY"] = "History";
	["ITEM"] = "Item";
	["ITEM_ID"] = "Item ID";
	["ITEM_SLOT"] = "Slot";
	["COMPANION_PETS"] = "Companion Pets";
	["DROP_RATE"] = "Drop Rate";
	["MOUNT"] = "Mount";
	["MOUNTS"] = "Mounts";
	["MOUNT_ID"] = "Mount ID";
	["MUSIC_ROLL"] = "Music Roll";
	["MUSIC_ROLLS"] = "Music Rolls";
	["MUSIC_ROLL_ID"] = "Music Roll ID";
	["NPC"] = "NPC";
	["NPC_ID"] = "NPC ID";
	["PET"] = "Pet";
	["QUEST"] = "Quest";
	["QUEST_ID"] = "Quest ID";
	["SET_ID"] = "Gear Set ID";
	["SPECIES_ID"] = "Species ID";
	["SPELL_ID"] = "Spell ID";
	["TOY"] = "Toy";
	["TOY_ID"] = "Toy ID";
	["ILLUSION_ID"] = "Illusion ID";
	["VIGNETTE_ID"] = "Vignette ID";
	["VISUAL_ID"] = "Visual ID";
	["COLLECTED_ICON"] = "|TInterface\\Addons\\AllTheThings\\assets\\known:0|t |cff15abff|r";			-- Acquired the colors and icon from CanIMogIt.
	["NOT_COLLECTED_ICON"] = "|TInterface\\Addons\\AllTheThings\\assets\\unknown:0|t |cffff9333|r";	-- Acquired the colors and icon from CanIMogIt.
	["COLLECTED"] = "|TInterface\\Addons\\AllTheThings\\assets\\known:0|t |cff15abffCollected|r";			-- Acquired the colors and icon from CanIMogIt.
	["NOT_COLLECTED"] = "|TInterface\\Addons\\AllTheThings\\assets\\unknown:0|t |cffff9333Not Collected|r";	-- Acquired the colors and icon from CanIMogIt.
	["COMPLETE"] = "|TInterface\\Addons\\AllTheThings\\assets\\known:0|t |cff15abffComplete|r";	-- Acquired the colors and icon from CanIMogIt.
	["INCOMPLETE"] = "|TInterface\\Addons\\AllTheThings\\assets\\unknown:0|t |cffff9333Incomplete|r";	-- Acquired the colors and icon from CanIMogIt.
	["WORLD"] = "World";
	["WORLD_DROPS"] = "World Drops";
	["ZONE"] = "Zone";
	["ZONES"] = "Zones";
	["ZONE_ID"] = "Zone ID";
	["GEAR_SETS"] = "Gear Sets";
	["ITEM_SETS"] = "Item Sets";
	["CLASS_SETS"] = "Class Sets";
	["DUNGEON_SETS"] = "Dungeon Sets";
	["PROMOTIONS"] = "Promotions";
	["PROFESSIONS"] = "Professions";
	["HOLIDAYS"] = "Holidays";
	["EVENTS"] = "World Events";
	["SPECIAL_EVENTS"] = "Special Events";
	["WARCRAFT_ANNIVERSARIES"] = "Warcraft Anniversaries";
	["SUBZONE"] = "Sub Zone";
	["SUBZONES"] = "Sub Zones";
	["SUBZONE_ID"] = "Sub Zone ID";
	["MAP"] = "Map";
	["MAP_ID"] = "Map ID";
	["MAP_ID_INVALID_WARNING"] = "Invalid Map ID. Zone in to cache.";
	["REQUIRES_LEVEL"] = "Requires Level";
	["SOURCE"] = "Source";
	["SOURCE_ID"] = "Source ID";
	["SOURCE_ID_MISSING"] = "Source ID Missing. Collection detection may not work. Please report this item to Crieve-Sargeras. If you also know the sourceID, provide that information as well.";
	["SPECIES_ID_MISSING"] = "Species ID Missing. Collection detection will not work. If you know the Species ID associated with this item, please report this information to Crieve-Sargeras.";
	
	["ABBREVIATIONS"] = {
		["ALL THE THINGS"] = "ATT",
		["Dungeons & Raids"] = "D&R",
		["Classic -> "] = "",
		["Burning Crusade"] = "BC",
		["Wrath of the Lich King"] = "WotLK",
		["Cataclysm"] = "CATA",
		["Mists of Pandaria"] = "MISTS",
		["Warlords of Draenor"] = "WoD",
		["Raid Finder"] = "LFR",
		["Looking For Raid"] = "LFR",
		["Normal"] = "N",
		["Heroic"] = "H",
		["Mythic"] = "M",
		[" Player"] = "M",
	};
	
	-- Music / Sound Management (You can add your own sounds for this if you want.)
	["AUDIO_FANFARE_TABLE"] = {
		"Interface\\AddOns\\AllTheThings\\assets\\fanfare1.ogg",
		"Interface\\AddOns\\AllTheThings\\assets\\fanfare2.ogg",
		"Interface\\AddOns\\AllTheThings\\assets\\fanfare3.ogg",
		"Interface\\AddOns\\AllTheThings\\assets\\fanfare4.ogg",
		"Interface\\AddOns\\AllTheThings\\assets\\fanfare5.ogg",
		"Interface\\AddOns\\AllTheThings\\assets\\fanfare6.ogg"
	};
	["AUDIO_REMOVE_TABLE"] = {
		"Interface\\AddOns\\AllTheThings\\assets\\remove1.ogg"
	};
	
	["FILTER_ID_TYPES"] = {
		-- "Armor Types"
		[1] = INVTYPE_HOLDABLE, --"Held in Off-Hand",
		[2] = "Cosmetic",
		[3] = INVTYPE_CLOAK, -- "Cloaks",
		[4] = "Cloth",
		[5] = "Leather",
		[6] = "Mail",
		[7] = "Plate",
		[8] = SHIELDSLOT, --"Shields",
		[9] = INVTYPE_TABARD, --"Tabards",
		[10] = INVTYPE_BODY, --"Shirts",
		
		-- PADDING for extra types, if necessary
		
		-- "Weapon Types"
		[20] = "Daggers",
		[21] = "One-Handed Axes",
		[22] = "Two-Handed Axes",
		[23] = "One-Handed Maces",
		[24] = "Two-Handed Maces",
		[25] = "One-Handed Swords",
		[26] = "Two-Handed Swords",
		[27] = "Wands",
		[28] = "Staves",
		[29] = "Polearms",
		[30] = "Spears",
		[31] = "Guns",
		[32] = "Bows",
		[33] = "Crossbows",
		[34] = "Fist Weapons",
		[35] = "Warglaives",
		[36] = "Miscellaneous",
		
		-- PADDING for extra types, if necessary
		
		-- "Non-Equipment Types"
		[100] = TUTORIAL_TITLE53, --"Mounts",
		[101] = "Companion Pets",
		[102] = "Toys",
		[103] = "Illusions",
		[104] = ITEM_BIND_QUEST, --"Quest Items",
		[105] = TRACKER_FILTER_ACHIEVEMENTS, --"Achievements",
		[106] = CALENDAR_FILTER_WEEKLY_HOLIDAYS, --"Holiday",
		[107] = "Vignettes",
		[108] = "Music Rolls",
		[109] = HEIRLOOMS, -- "Heirlooms",
		
		-- "Recipes"
		[200] = AUCTION_CATEGORY_RECIPES, --"Recipes",
	};
	
	-- These need to be localized manually.
	["NPC_ID_ICONS"] = {
		-- Achievement_Boss_ShadeOfEranikus
		[0] = "Interface\\Icons\\INV_TreasureChest_FelfireCitadel",
		[-1] = "Interface\\Icons\\Achievement_Garrison_Horde_PVE",
		[-2] = "Interface\\Icons\\INV_Misc_Coin_02", 	-- Vendors
		[-3] = "Interface\\Icons\\INV_Helm_Cloth_WitchHat_B_01",
		[-4] = "Interface\\Icons\\ability_warrior_innerrage",
		[-7] = "Interface\\Icons\\Inv_offhand_1h_artifactskulloferedar_d_05",	-- World Bosses (Achievement_Boss_ShadeOfEranikus)
		[-9] = "Interface\\Icons\\TRADE_ARCHAEOLOGY",
		[-12] = "Interface\\Icons\\Ability_Warlock_DemonicEmpowerment",
		[-13] = "Interface\\Icons\\Achievement_Reputation_Ogre",
		[-14] = "Interface\\Icons\\INV_Misc_Head_Elf_02",
		[-16] = "Interface\\Icons\\Spell_Shadow_DeathScream",	-- Rares
		[-17] = "Interface\\Icons\\inv_misc_book_07", 		-- Quests
		[-18] = "Interface\\Icons\\icon_scenarios",			-- Scenarios
		[-19] = "Interface\\Icons\\achievement_scenario_arenaofannihilation",
		[-25] = "Interface\\Icons\\Tracking_WildPet", 		-- Pet Battles	
		[-29] = "Interface\\Icons\\Inv_misc_bag_17", -- Raid Finder Bag
		[-34] = "Interface\\Icons\\Achievement_Reputation_06",
		[-363] = "Interface\\Icons\\achievement_reputation_argentchampion", -- Argent Tournament
		[-1000] = "Interface\\Icons\\achievement_transmog_collections",
		[-318] = "Interface\\Icons\\garrison_purplearmor",
		[-319] = "Interface\\Icons\\garrison_purpleweapon",
		[-320] = "Interface\\Icons\\inv_helmet_03",
		[-321] = "Interface\\Icons\\inv_shoulder_05",
		[-322] = "Interface\\Icons\\inv_misc_cape_11",
		[-323] = "Interface\\Icons\\inv_chest_chain",
		[-324] = "Interface\\Icons\\inv_shirt_grey_01",
		[-325] = "Interface\\Icons\\inv_misc_tournaments_tabard_gnome",
		[-326] = "Interface\\Icons\\inv_bracer_07",
		[-327] = "Interface\\Icons\\Inv_gauntlets_24",
		[-328] = "Interface\\Icons\\inv_belt_24",
		[-329] = "Interface\\Icons\\inv_pants_09",
		[-330] = "Interface\\Icons\\inv_boots_09",
		[-334] = "Interface\\Icons\\inv_axe_17",
		[-335] = "Interface\\Icons\\inv_axe_09",
		[-346] = "Interface\\Icons\\inv_weapon_bow_05",
		[-347] = "Interface\\Icons\\inv_weapon_crossbow_01",
		[-333] = "Interface\\Icons\\inv_weapon_shortblade_01",
		[-348] = "Interface\\Icons\\inv_misc_monsterclaw_02",
		[-345] = "Interface\\Icons\\inv_weapon_rifle_01",
		[-331] = "Interface\\Icons\\inv_misc_orb_01",
		[-336] = "Interface\\Icons\\inv_mace_02",
		[-337] = "Interface\\Icons\\inv_hammer_16",
		[-343] = "Interface\\Icons\\inv_spear_04",
		[-332] = "Interface\\Icons\\inv_shield_06",
		[-342] = "Interface\\Icons\\inv_staff_27",
		[-338] = "Interface\\Icons\\inv_sword_04",
		[-339] = "Interface\\Icons\\inv_sword_07",
		[-341] = "Interface\\Icons\\inv_wand_02",
		[-9901] = "Interface\\Icons\\ClassIcon_Priest", -- "Priest",
		[-9902] = "Interface\\Icons\\ClassIcon_Mage", -- "Mage",
		[-9903] = "Interface\\Icons\\ClassIcon_Warlock", -- "Warlock",
		[-9904] = "Interface\\Icons\\ClassIcon_Druid", -- "Druid",
		[-9905] = "Interface\\Icons\\ClassIcon_Rogue", -- "Rogue",
		[-9906] = "Interface\\Icons\\ClassIcon_Monk", -- "Monk",
		[-9907] = "Interface\\Icons\\ClassIcon_DemonHunter", -- "Demon Hunter",
		[-9908] = "Interface\\Icons\\ClassIcon_Hunter", -- "Hunter",
		[-9909] = "Interface\\Icons\\ClassIcon_Shaman", -- "Shaman",
		[-9910] = "Interface\\Icons\\ClassIcon_Paladin", -- "Paladin",
		[-9911] = "Interface\\Icons\\ClassIcon_Warrior", -- "Warrior",
		[-9912] = "Interface\\Icons\\ClassIcon_DeathKnight", -- "Death Knight",
		[-9914] = "Interface\\FriendsFrame\\PlusManz-Alliance", -- Alliance
		[-9913] = "Interface\\FriendsFrame\\PlusManz-Horde", -- Horde
		[150] = "Interface\\Icons\\ability_warrior_innerrage",
		[69471] = "Interface\\Icons\\Trade_archaeology_chestoftinyglassanimals",
		[69341] = "Interface\\Icons\\Trade_archaeology_chestoftinyglassanimals",
		[69749] = "Interface\\Icons\\Trade_archaeology_chestoftinyglassanimals",
		[70080] = "Interface\\Icons\\Trade_archaeology_chestoftinyglassanimals",
		[69347] = "Interface\\Icons\\Trade_archaeology_chestoftinyglassanimals",
		[69633] = "Interface\\Icons\\Trade_archaeology_chestoftinyglassanimals",
		[69339] = "Interface\\Icons\\Trade_archaeology_chestoftinyglassanimals",
		[69767] = "Interface\\Icons\\Trade_archaeology_chestoftinyglassanimals",
		[69396] = "Interface\\Icons\\Trade_archaeology_chestoftinyglassanimals",
		[69769] = "Interface\\Icons\\Inv_misc_archaeology_trollgolem",
		[69841] = "Interface\\Icons\\Inv_misc_archaeology_trollgolem", 
		[69842] = "Interface\\Icons\\Inv_misc_archaeology_trollgolem",
		[69768] = "Interface\\Icons\\Inv_misc_archaeology_trollgolem",
		[50817] = "Interface\\Icons\\inv_misc_head_dragon_black",
		[50341] = "Interface\\Icons\\inv_misc_head_dragon_black",
		[50354] = "Interface\\Icons\\inv_misc_head_dragon_black",
		[50332] = "Interface\\Icons\\inv_misc_head_dragon_black",
		[50789] = "Interface\\Icons\\inv_misc_head_dragon_black",
		[50831] = "Interface\\Icons\\inv_misc_head_dragon_black",
		[50733] = "Interface\\Icons\\inv_misc_head_dragon_black",
		[50769] = "Interface\\Icons\\inv_misc_head_dragon_black",
		[70096] = "Interface\\Icons\\inv_misc_head_dragon_black",
		[50358] = "Interface\\Icons\\inv_misc_head_dragon_black",
		[70530] = "Interface\\Icons\\inv_misc_head_dragon_black",
		[69251] = "Interface\\Icons\\inv_misc_head_dragon_black",
		
		
	};
	["NPC_ID_NAMES"] = {
-- Used #'s 
-- 0 to -29, [Common]
-- -30 to -48 (Custom NPC's)
-- -49 to -65 [Holidays]
-- -99 to -199 [Garrison]
-- -299 to -317 [Other]
-- -499 to -538 [Anniversaries and Events]
-- -1000 to -1500 [BOE Sets]
-- -3175-3189 [Weapon Sets]
-- -3190-3199 [Holiday Sets]; working backwards
-- -3150-3600 [Dungeon and Event Armor Sets]
-- Commonly used 
		[-2] = TUTORIAL_TITLE20, 	-- Vendors
		[-3] = CALENDAR_FILTER_WEEKLY_HOLIDAYS, -- Holiday
		[-4] = TRACKER_FILTER_ACHIEVEMENTS, 	-- Achievements
		[-5] = UNIT_NAME_PLAYER_TITLE, 		-- Titles
		[-15] = AUCTION_CATEGORY_RECIPES, 	-- Recipes
		[-16] = BATTLE_PET_BREED_QUALITY4, 	-- Rares
		[-17] = TRACKER_HEADER_QUESTS, 		-- Quests
		[-18] = SCENARIOS, 		-- Scenarios
		[-25] = SHOW_PET_BATTLES_ON_MAP_TEXT, 		-- Pet Battles	
		[-34] = TRACKER_HEADER_WORLD_QUESTS, -- World Quests
		[-35] = ORDER_HALL_MISSIONS, -- Class Hall Missions
-- Dungeon and Raid
		[0] = ZONE.." "..BATTLE_PET_SOURCE_1, 	-- Zone Drop
		[-1] = BATTLE_PET_BREED_QUALITY2.." "..TRANSMOG_SOURCE_1,	-- Common Boss Drop
		[-6] = GUILD_INTEREST_DUNGEON, 		-- Dungeons
		[-7] = WORLD.." "..RAID_BOSSES, 		-- World Bosses
		[-8] = "Evergreen Plot",
		[-9] = "Cache of Madness (Requires 225 Archeology)",
		[-10] = PLAYER_DIFFICULTY1, 	-- Normal
		[-11] = PLAYER_DIFFICULTY2, 	-- Heroic
		[-12] = "East Entrance (Demons)",
		[-13] = "North Entrance (Ogres)",
		[-14] = "West Entrance (Elves)",	
		[-19] = DUNGEON_FLOOR_PROVINGGROUNDS1, 		-- Arena of Annihilation
		[-27] = PLAYER_DIFFICULTY6, 	-- Mythic
		[-28] = PLAYER_DIFFICULTY3, 	-- Raid Finder
		[-29] = PLAYER_DIFFICULTY3.." "..BAGSLOT, -- Raid Finder Bag
-- Order Hall
		[-20] = "Order Halls",
		[-21] = ORDER_HALL_PALADIN, 	-- Sanctum of Light
		[-22] = ORDER_HALL_ROGUE, 		-- The Hall of Shadows
		[-23] = ORDER_HALL_DEATHKNIGHT, 		-- Acherus
		[-24] = ORDER_HALL_WARLOCK, 	-- Dreadscar Rift
-- Custom NPC's
		[-33] = PROFESSIONS_FISHING,		-- Fishing
-- World Events
		[-48] = MINIMAP_TRACKING_STABLEMASTER,		-- Stable Master
		[-49] = WORLD.." "..EVENTS_LABEL, 		-- World Events
		[-47] = "Lunar Festival",
		[-50] = "Love is in the Air",
		[-51] = "Noblegarden",
		[-52] = "Children's Week",
		[-53] = "Midsummer Fire Festival [Alliance]", -- Horde
		[-54] = "Midsummer Fire Festival [Horde]", -- Alliance
		[-55] = "Pirate's Day",
		[-56] = "Brewfest",
		[-57] = "Harvest Festival",
		[-58] = "Hallow's End",
		[-59] = "Day of the Dead",
		[-60] = "Pilgrim's Bounty",
		[-61] = "Feast of Winter Veil",
		[-62] = "Stranglethorn Fishing Extravaganza",
		[-63] = "Trial of Style",
		[-64] = "WoW Anniversaries",
		[-65] = "Blizzard Promotions",			
-- Garrison 
		[-99] = STABLES, 	-- Stables
		[-100] = "Shipyard Mission Table",
		[-101] = "Garrison Mission Table",
		[-102] = "Alchemy Lab",
		[-103] = "Barn",
		[-104] = "Barracks",
		[-105] = "Enchanter's Study",
		[-106] = "Engineering Works",
		[-107] = "Fishing Shack",
		[-108] = "Gem Boutique",
		[-109] = "Gladiator's Sanctum",
		[-110] = "Herb Garden",
		[-111] = "Lumber Mill",
		[-112] = "Menagerie",
		[-113] = "Salvage Yard",
		[-114] = "Scribe's Quarters",
		[-115] = "Storehouse",
		[-116] = "Tailoring Emporium",
		[-117] = "The Forge",
		[-118] = "The Tannery",
		[-119] = "Trading Post",
		--Horde
		[-120] = "Frostwall Mines",
		[-121] = "Frostwall Tavern",
		[-122] = "Goblin Workshop",
		[-123] = "Spirit Lodge",
		[-124] = "War Mill",
		-- Alliance
		[-125] = "Dwarven Bunker",
		[-126] = "Gnomish Gearworks",
		[-127] = "Lunarfall Excavation",
		[-128] = "Lunarfall Inn",
		[-129] = "Mage Tower",
		--Transmog Sets
		[-130] = "Thunderlord Set",
		[-131] = "Shadowmoon Set",
		[-132] = "Blackrock Set",
		[-133] = "Warsong Set",
		[-134] = "Orgrimmar Set",
		[-135] = "Stormwind Set",
		--Invasions
		[-136] = GARRISON_LANDING_INVASION, 	-- Garrison Invasion
		[-137] = "Bronze-Silver",
		[-138] = "Gold-Platinum",
		[-139] = RAID_BOSSES, 	-- Bosses
		-- Class Trial Sets
		[-140] = "Communal",
		[-141] = "Felsoul",
		[-142] = "Heart-Lesion",
		[-143] = "Lightdrinker",
		[-144] = "Mistdancer",
		[-145] = "Mountainsage",
		[-146] = "Oathsworn",
		[-147] = "Springrain",
		[-148] = "Streamtalker",
		[-149] = "Sunsoul",
		[-150] = "Trailseeker",
		[-151] = "Soulare of Andorhal",
		[-152] = "Garrison Campaign",
		
-- Other1
		[-299] = GARRISON_MISSIONS, -- Missions
		[-309] = TRADE_SKILLS, 		-- Professions
		[-318] = ARMOR, 		-- Armor
		[-319] = AUCTION_CATEGORY_WEAPONS, 	-- Weapons
		[-320] = INVTYPE_HEAD, 		-- Head
		[-321] = INVTYPE_SHOULDER, 	-- Shoulder
		[-322] = INVTYPE_CLOAK,		-- Back
		[-323] = INVTYPE_CHEST, 	-- Chest
		[-324] = INVTYPE_BODY, 		-- Shirt
		[-325] = INVTYPE_TABARD, 	-- Tabard
		[-326] = INVTYPE_WRIST, 	-- Wrist
		[-327] = INVTYPE_HAND, 		-- Hands
		[-328] = INVTYPE_WAIST, 	-- Waist
		[-329] = INVTYPE_LEGS, 		-- Legs
		[-330] = INVTYPE_FEET, 		-- Feet
		[-331] = INVTYPE_HOLDABLE, 	-- Held in Off-hand
		[-332] = SHIELDSLOT, 		-- Shield
		[-333] = "Daggers",
		[-334] = "1H Axes",
		[-335] = "2H Axes",
		[-336] = "1H Maces",
		[-337] = "2H Maces",
		[-338] = "1H Swords",
		[-339] = "2H Swords",
		[-340] = "Warglaives",
		[-341] = "Wands",
		[-342] = "Staffs",
		[-343] = "Polearms",
		[-344] = "Spears",
		[-345] = "Guns",
		[-346] = "Bows",
		[-347] = "Crossbows",
		[-348] = "Fist Weapons",
		[-350] = "Level 1-9",
		[-351] = "Level 10-19",
		[-352] = "Level 20-29",
		[-353] = "Level 30-39",
		[-354] = "Level 40-49",
		[-355] = "Level 50-60",
		[-356] = "Assault on the Dark Portal",
		[-357] = "Sparring Arena",
		[-358] = "Lumber Yard",
		[-359] = "Brewery",
		[-360] = "Arcane Sanctum",
		[-361] = "Artillery Tower",
		[-362] = "Peak of Serenity",
		[-363] = "The Argent Tournament",
		

-- Blizzard Events and Anniversaries
		[-577] = "World of Warcraft Movie",
		[-576] = "StarCraft II: Legacy of the Void",
		[-575] = "Diablo III: Reaper of Souls",
		[-574] = "Diablo III Annual Pass",
		[-573] = "Scroll of Resurrection",
		[-572] = "Heroes of the Storm",
		[-571] = BATTLE_PET_SOURCE_10, 	-- In-Game Shop
		[-570] = BATTLE_PET_SOURCE_9, 	-- Trading Card Game
		[-569] = "Refer-A-Friend",
		[-568] = "Overwatch Origins & Collector's",
		[-567] = "Hearthstone",
		[-566] = "Diablo III",
		[-565] = "Starcraft II: Heart of the Swarm",
		[-564] = "Starcraft II: Wings of Liberty",
		[-563] = "Azeroth's Choppers",
		[-562] = "2008 World Wide Invitational",
		[-561] = "2007 World Wide Invitational",
		[-560] = "World of Warcraft",
		[-559] = "Blizzcon 2020",
		[-558] = "Blizzcon 2019",
		[-557] = "Blizzcon 2018",
		[-556] = "Blizzcon 2017",
		[-555] = "Blizzcon 2016",
		[-554] = "Blizzcon 2015",
		[-553] = "Blizzcon 2014",
		[-552] = "Blizzcon 2013",
		[-551] = "Blizzcon 2011",
		[-550] = "Blizzcon 2010",
		[-549] = "Blizzcon 2009",
		[-548] = "Blizzcon 2008",
		[-547] = "Blizzcon 2007",
		[-546] = "Blizzcon 2006",
		[-545] = "Blizzcon 2005",
		[-544] = "WoW Collector Editions",
		[-543] = "Legion Invasions",
		[-542] = "Battlefield: Barrens",
		[-541] = "Battle for Sun's Reach", -- Will look into if needed or not
		[-540] = "The Scourge Invasion",
		[-539] = "Gates of Ahn'Qiraj",
		[-538] = "Diablo Promotion",
		[-537] = "Starcraft Promotion",
		[-536] = "Overwatch Promotion",
		[-535] = "Blizzcon Event",
		[-534] = "Collector's Edition",
		[-533] = "Hearthstone Promotion",
		[-532] = "Heroes of the Storm Promotion",
		[-531] = "Olympic Events",
		[-530] = "Diablo's 20th Anniversary",
		[-526] = "Legion: Legion Invasion",
		[-525] = "Warlords of Draenor: Iron Horde Incursion",
		[-524] = "Mists of Pandaria",
		[-523] = "Cataclysm: Elemental Unrest",
		[-522] = "Wrath of the Lich King: Zombie Infestation",
		[-521] = "Burning Crusade: Dark Portal Opens",
		[-520] = "Expansion Pre-Launch Events",
		[-509] = "WoW 13th Anniversary",
		[-508] = "WoW 12th Anniversary",
		[-506] = "WoW 10th Anniversary",
		[-501] = "WoW 5th Anniversary",
		[-500] = "WoW 4th Anniversary",
		[-499] = "Elemental Lords (Cataclysm)", -- [Cataclysm Pre-Launch
		[-498] = "Twisting Nether", -- Demon Hunter Tier 2 Class Hall Advancement
		[-497] = "Demonic Offering", -- Warlock Tier 2 Class Hall Advancement
				
		[-1000] = WARDROBE_SETS, 	-- Sets
		
-- Factions

		[-9914] = FACTION_ALLIANCE, -- Alliance
		[-9913] = FACTION_HORDE, -- Horde
		
-- Classes [Needs localization]
		[-9901] = "Priest",
		[-9902] = "Mage",
		[-9903] = "Warlock",
		[-9904] = "Druid",
		[-9905] = "Rogue",
		[-9906] = "Monk",
		[-9907] = "Demon Hunter",
		[-9908] = "Hunter",
		[-9909] = "Shaman",
		[-9910] = "Paladin",
		[-9911] = "Warrior",
		[-9912] = "Death Knight",

-- Tier/Dungeon/Event/Holiday Sets 
		--Class Sets
		[-5352] = GARRISON_TIER.." "..WARDROBE_SETS,		-- Tier Sets
		[-5351] = "Class Hall Order Sets",
		[-5350] = "Class Trial Sets",
		-- Class Hall Order Sets
		[-6011] = "Deathlord's Battleplate", -- Death Knight
		[-6010] = "Battlelord's Plate", -- Warrior
		[-6009] = "Battleplate of the Silver Hand", -- Paladin
		[-6008] = "Raiment of the Farseer", -- Shaman
		[-6007] = "Guise of the Unseen Path", -- Hunter
		[-6006] = "Battlegear of the Shattered Abyss", -- Demon Hunter
		[-6005] = "Grandmaster's Finery", -- Monk
		[-6004] = "Battlegear of the Uncrowned", -- Rogue
		[-6003] = "Dreamgrove Raiment", -- Druid
		[-6002] = "Vestments of the Black Harvest", -- Warlock
		[-6001] = "Vesture of Tirisgarde", -- Mage
		[-6000] = "Regalia of the High Priest", -- Priest

--[[		-- Tier Set Numbers Localization
		[-5992] = GARRISON_CURRENT_LEVEL.." "..WARDROBE_SETS, -- Tier 9 Sets
--]]		
		-- Tier 20 Sets
		[-4098] = "Gravewarden Armaments", -- Death Knight
		[-4097] = "Titantic Onslaught Armor", -- Warrior
		[-4096] = "Radiant Lightbringer Armor", -- Paladin
		[-4095] = "Regalia of the Skybreaker", -- Shaman
		[-4094] = "Wildstalker Armor", -- Hunter
		[-4093] = "Demonbane Armor", -- Demon Hunter
		[-4092] = "Xuen's Battlegear", -- Monk
		[-4091] = "Fanged Slayer's Armor", -- Rogue
		[-4090] = "Stormheart Raiment", -- Druid
		[-4089] = "Diabolic Raiment", -- Warlock
		[-4088] = "Regalia of the Arcane Tempest", -- Mage
		[-4087] = "Vestments of Blind Absolution", -- Priest
		-- Tier 19 Sets
		[-4086] = "Dreadwyrm Battleplate", -- Death Knight
		[-4085] = "Warplate of the Obsidian Aspect", -- Warrior
		[-4084] = "Battleplate of the Highlord", -- Paladin
		[-4083] = "Regalia of Bound Elements", -- Shaman
		[-4082] = "Eagletalon Battlegear", -- Hunter
		[-4081] = "Vestment of Second Sight", -- Demon Hunter
		[-4080] = "Vestments of Enveloped Dissonance", -- Monk
		[-4079] = "Doomblade Battlegear", -- Rogue
		[-4078] = "Garb of the Astral Warden", -- Druid
		[-4077] = "Legacy of Azj'Aqir", -- Warlock
		[-4076] = "Regalia of Everburning Knowledge", -- Mage
		[-4075] = "Vestments of the Purifier", -- Priest
		-- Tier 6 Sets (Hyjal Summit, Black Temple, & Sunwell Plateau)
		[-3349] = "Onslaught ", -- Protection Warrior
		[-3348] = "Onslaught ", -- Arms/Fury Warrior
		[-3347] = "Lightbringer ", -- Retribution Paladin
		[-3346] = "Lightbringer ", -- Protection  Paladin
		[-3345] = "Lightbringer ", -- Holy Paladin
		[-3344] = "Skyshatter ", -- Restoration Shaman
		[-3343] = "Skyshatter ", -- Enhancement Shaman
		[-3342] = "Skyshatter ", -- Elemental Shaman
		[-3341] = "Gronnstlaker's Armor", -- Hunter
		[-3340] = "Slayer's Armor", -- Rogue
		[-3339] = "Thunderheart ", -- Restoration Druid
		[-3338] = "Thunderheart ", -- Balance Druid
		[-3337] = "Thunderheart ", -- Guardian/Feral Druid
		[-3336] = "Malefic Raiment", -- Warlock
		[-3335] = "Tempest Regalia", -- Mage
		[-3334] = "Absolution Regalia", -- Shadow Priest
		[-3333] = "Vestments of Absolution", -- Discipline/Holy Priest
		-- Tier 5 Sets (Serpentshrine Cavern & The Eye)
		[-3332] = "Destroyer ", -- Protection Warrior
		[-3331] = "Destroyer ", -- Arms/Fury Warrior
		[-3330] = "Crystalforge ", -- Retribution Paladin
		[-3329] = "Crystalforge ", -- Protection  Paladin
		[-3328] = "Crystalforge ", -- Holy Paladin
		[-3327] = "Cataclysm ", -- Restoration Shaman
		[-3326] = "Cataclysm ", -- Enhancement Shaman
		[-3325] = "Cataclysm ", -- Elemental Shaman
		[-3324] = "Rift Stalker Armor", -- Hunter
		[-3323] = "Deathmantle", -- Rogue
		[-3322] = "Nordrassil ", -- Restoration Druid
		[-3321] = "Nordrassil ", -- Balance Druid
		[-3320] = "Nordrassil ", -- Guardian/Feral Druid
		[-3319] = "Corruptor ", -- Warlock
		[-3318] = "Tirisfal Regalia", -- Mage
		[-3317] = "Avatar ", -- Shadow Priest
		[-3316] = "Avatar ", -- Discipline/Holy Priest
		-- Tier 4 Sets (Karazhan, Gruul's Lair, & Magtheridon's Lair)
		[-3315] = "Warbringer Armor", -- Protection Warrior
		[-3314] = "Warbringer Battlegear", -- Arms/Fury Warrior
		[-3313] = "Justicar Battlegear", -- Retribution Paladin
		[-3312] = "Justicar Armor", -- Protection  Paladin
		[-3311] = "Justicar Raiment", -- Holy Paladin
		[-3310] = "Cyclone Raiment", -- Restoration Shaman
		[-3309] = "Cyclone Harness", -- Enhancement Shaman
		[-3308] = "Cyclone Regalia", -- Elemental Shaman
		[-3307] = "Doom Stalker Armor", -- Hunter
		[-3306] = "Netherblade", -- Rogue
		[-3305] = "Malorne Raiment", -- Restoration Druid
		[-3304] = "Malorne Regalia", -- Balance Druid
		[-3303] = "Malorne Harness", -- Guardian/Feral Druid
		[-3302] = "Voidheart Raiment", -- Warlock
		[-3301] = "Aldor Regalia", -- Mage
		[-3300] = "Incarnate Raiment", -- Shadow Priest
		[-3299] = "Incarnate Regalia", -- Discipline/Holy Priest
		-- Dungeon 3 Sets [Tier 3.5]
		[-3298] = "Doomplate Battlegear", -- Plate
		[-3297] = "Desolation Battlegear", -- Mail
		[-3296] = "Wastewalker Armor", -- Leather
		[-3295] = "Mana-Etched Regalia", -- Cloth
		[-3294] = "Bold Armor", -- Warrior
		[-3293] = "Righteous Armor", -- Paladin
		[-3292] = "Tidefury Raiment", -- Shaman
		[-3291] = "Beast Lord Armor", -- Hunter
		[-3290] = "Assassination Armor", -- Rogue
		[-3289] = "Moonglade Rainment", -- Druid
		[-3288] = "Oblivion Raiment", -- Warlock
		[-3287] = "Incanter's Regalia", -- Mage
		[-3286] = "", -- Priest
		-- Tier 3 Sets (Naxxramas - Vanilla)
		[-3285] = "Dreadnaught's Battlegear", -- Warrior
		[-3284] = "Redemption Armor", -- Paladin
		[-3283] = "The Earthshatter", -- Shaman
		[-3282] = "Cryptstalker Armor", -- Hunter
		[-3281] = "Bonescythe Armor", -- Rogue
		[-3280] = "Dreamwalker Raiment", -- Druid
		[-3279] = "Plagueheart Raiment", -- Warlock
		[-3278] = "Frostfire Regalia", -- Mage
		[-3277] = "Vestments of Faith", -- Priest
		-- Brood of Nozdormu Set (Temple of Ahn'Qiraj) [Tier 2.5]
		[-3276] = "Conqueror's Battlegear",  -- Warrior
		[-3275] = "Avenger's Battlegear", -- Paladin
		[-3274] = "Stormcaller's Garb", -- Shaman
		[-3273] = "Striker's Garb", -- Hunter
		[-3272] = "Deathdealer's Embrace", -- Rogue
		[-3271] = "Genesis Raiment", -- Druid
		[-3270] = "Doomcaller's Attire", -- Warlock
		[-3269] = "Enigma Vestments", -- Mage
		[-3268] = "Garments of the Oracle", -- Priest
		-- Tier 2 Sets (Blackwing Lair & Onyxia's Lair]
		[-3267] = "Battlegear of Wrath", -- Warrior
		[-3266] = "Judgement Armor", -- Paladin
		[-3265] = "The Ten Storms", -- Shaman
		[-3264] = "Dragonstalker", -- Hunter
		[-3263] = "Bloodfang Armor", -- Rogue
		[-3262] = "Stormrage Raiment", -- Druid
		[-3261] = "Nemesis Raiment", -- Warlock
		[-3260] = "Vault-Minder's Set",
		[-3259] = "Terrorweave Set",
		-- Zandalar Tribe Set (Zul'Gurub) [Tier 1.5]
		[-3258] = "Vindicator's Battlegear", -- Warrior
		[-3257] = "Freethinker's Armor", -- Paladin
		[-3256] = "Augur's Regalia", -- Shaman
		[-3255] = "Predator's Armor", -- Hunter
		[-3254] = "Madcap's Outfit", -- Rogue
		[-3253] = "Haruspex's Garb", -- Druid
		[-3252] = "Demoniac's Threads", -- Warlock
		[-3251] = "Illusionist's Attire", -- Mage
		[-3250] = "Confessor's Raiment", -- Priest
		-- Tier 1 Sets (Molten Core)
		[-3249] = "Sunfrost Set",
		[-3248] = "Seawitch Set",
		[-3247] = "Roggthread Set",
		[-3246] = "Riven Priesthood Set",
		[-3245] = "Night Dreamer Set",
		[-3244] = "Netherwhisper Set",
		[-3243] = "Manawracker Set",
		[-3242] = "Bonespeaker Set",
		[-3241] = "Arcane Singed Set",
		-- Cenarion Circle Set (Ruins of Ahn'Qiraj")
		[-3240] = "Battlegear of Unyielding Strength", -- Warrior
		[-3239] = "Battlegear of Eternal Justice", -- Paladin
		[-3238] = "Gift of the Gathering Storm", -- Shaman
		[-3237] = "Trappings of the Unseen Path", -- Hunter
		[-3236] = "Emblems of Veiled Shadows", -- Rogue
		[-3235] = "Symbols of Unending Life", -- Druid
		[-3234] = "Implements of Unspoken Names", -- Warlock
		[-3233] = "Trappings of Vaulted Secrets", -- Mage
		[-3232] = "Finery of Infinite Wisdom", -- Priest
		-- Instance Sets
		[-3231] = "Deathbone Guardian", -- Plate
		[-3230] = "Bloodmail Regalia", -- Mail
		[-3229] = "Cadaverous Garb", -- Leather
		[-3228] = "Necropile Raiment", -- Cloth
		[-3227] = "The Postmaster", -- Cloth
		[-3226] = "Ironweave Battlesuit", -- Cloth
		-- Anti-Undead Armor Sets [Vanilla Scourge Event]
		[-3225] = "Battlegear of Undead Slaying",
		[-3224] = "Garb of the Undead Slayer",
		[-3223] = "Undead Slayer's Armor",
		[-3222] = "Regalia of Undead Cleansing",
		-- Anti-Undead Armor Sets [Scourge Event]
		[-3221] = "Blessed Battlegear of the Undead Slaying",
		[-3220] = "Blessed Garb of the Undead Slayer",
		[-3219] = "Undead Slayer's Blessed Armor",
		[-3218] = "Blessed Regalia of Undead Cleansing",
		-- Dungeon 2 Sets [Tier 0.5]
		[-3217] = "Battlegear of Heroism", -- Warrior
		[-3216] = "Soulforge Armor", -- Paladin
		[-3215] = "The Five Thunders", -- Shaman
		[-3214] = "Beastmaster Armor", -- Hunter
		[-3213] = "Darkmantle Armor", -- Rogue
		[-3212] = "Feralheart Rainment", -- Druid
		[-3211] = "Deathmist Rainment", -- Warlock
		[-3210] = "Sorcerer's Regalia", -- Mage
		[-3209] = "Vestments of the Virtuous", -- Priest
		-- Dungeon 1 Sets [Tier 0]
		[-3208] = "Battlegear of Valor",  -- Warrior
		[-3207] = "Lightforge Armor", -- Paladin
		[-3206] = "The Elements", -- Shaman
		[-3205] = "Beaststalker Armor", -- Hunter
		[-3204] = "Shadowcraft Armor", -- Rogue
		[-3203] = "Wildheart Rainment", -- Druid
		[-3202] = "Dreadmist Rainment", -- Warlock
		[-3201] = "Magister's Regalia", -- Mage
		[-3200] = "Vestments of the Devout", -- Priest
		-- Holiday Sets
		[-3199] = "Midsummer Reveler Set",
		[-3198] = "Brewfest Garb",
		[-3189] = "Fel-Touched Weapons",
		[-3188] = "Dungeon, Tier and Class Sets",
		[-3187] = "Instance Sets",
		[-3186] = "Tier 0 (Dungeon Set 1)",
		[-3185] = "Tier 0.5 (Dungeon Set 2)",
		[-3184] = "Tier 1 (Molten Core)",
		[-3183] = "Tier 1.5 (Zul Gurub - Zandalar Tribe Set)",
		[-3182] = "Tier 2 (Blackwing Lair & Onyxia's Lair)",
		[-3181] = "Cenarion Circle Set (Ruins of Ahn'Qiraj)",
		[-3180] = "Tier 2.5 (Temple of Ahn'qiraj - Brood of Nozdormu Set)",
		[-3179] = "Tier 3 (Naxxramas - Vanilla)",
		[-3178] = "Tier 3.5 (Dungeon Set 3)",
		[-3177] = "Tier 4 (Karazhan, Gruul's Lair, & Magtheridon's Lair)",
		[-3176] = "Tier 5 (Serpentshrine Cavern & The Eye)",
		[-3175] = "Tier 6 (Hyjal Summit, Black Temple, and Sunwell Plateau)",
--[[	[-3174] = "7",
		[-3173] = "8",--]]
		[-3172] = "Tier 9 (Trial of the Crusader)",
--[[	[-3171] = "10",
		[-3170] = "11",
		[-3169] = "12",
		[-3168] = "13",
		[-3167] = "14",
		[-3166] = "15",
		[-3165] = "16",
		[-3164] = "17",
		[-3163] = "18", --]]
		[-3162] = "Tier 19 (The Nighthold)",
		[-3161] = "Tier 20 (Tomb of Sargeras)",
		[-3160] = INVTYPE_CLOAK, -- Cloak
		-- PvP Sets
		[-4192] = ELITE, -- Elite
		[-4191] = "Gladiator",
		[-4190] = "Combatant",
		[-4189] = CALENDAR_TYPE_PVP.." "..WARDROBE_SETS, -- PvP
		[-4188] = "Legacy Sets",
		[-4187] = "Season 1",
		[-4186] = "Season 2",
		[-4185] = "Season 3",
		[-4184] = "Season 4",
		[-4183] = "Season 5",
		[-4182] = "Season 6",
		[-4181] = "Season 7",
		[-4180] = "Season 8",
		[-4179] = "Season 9",
		[-4178] = "Season 10",
		[-4177] = "Season 12",
		[-4176] = "Season 13",
		[-4175] = "Season 14",
		[-4174] = "Season 15",
		[-4173] = "Season 16",
		[-4172] = "Warlords Season 1",
		[-4171] = "Warlords Season 2",
		[-4170] = "Warlords Season 3",
		[-4169] = "Legion Season 1 & 2",
		[-4168] = "Legion Season 3 & 4",
		[-4167] = "Legion Season 5 & 6",
		
		
-- To be removed when NpcDB is created
		[66467] = "G'nathus",
		[66990] = "Huggalon the Heart Watcher",
		[64403] = "Alani",
		[69983] = "Primal Direhorn",
		[69925] = "Zandalari Dinomancer",
		[69251] = "Quivering Filth",
		[69471] = "Spirit of Warlord Teng",
		[69341] = "Echo of Kros",
		[69749] = "Qi'nor",
		[70080] = "Windweaver Akil'amon",
		[69347] = "Incomplete Drakkari Colossus",
		[69633] = "Kor'dok and Tinzo the Emberkeeper",
		[69339] = "Electromancer Ju'le",
		[69767] = "Ancient Mogu Guardian",
		[69396] = "Cera",
		[81330] = "Warleader Tome",
		[101878] = "Felsoul Inquisitor",
		[92343] = "Captain Tomas",
		[23159] = "Okuno",
		[54401] = "Naresir Stormfury",		
		[54402] = "Lurah Wrathvine",	
		[25977] = "Yrma (Outside on boat)",
		[38858] = "Goodman the Closer",
		[37687] = "Alchemist Finklestein",
		[38316] = "Ormus the Penitent",	
		[37999] = "Alana Moonstrike",
		[37992] = "Tortunok",
		[37993] = "Gerardo the Suave",
		[37998] = "Talan Moonstrike",
		[38283] = "Malfus Grimfrost",
		[38284] = "Uvlus Banefire",
		[37696] = "Crusader Halford",
		[38054] = "Scott the Merciful",
		[37997] = "Yili",
		[37991] = "Ikfirus the Vile",
		[38840] = "Jedebia",
		[38841] = "Vol'guk",
		[38182] = "Niby the Almighty",
		[38181] = "Haragg the Unseen",
		[37688] = "Crusader Grimtong",		
		[594] = "Defias Henchman",
		[16080] = "Mor Grayhoof Summonable Read Description",
		[111573] = "Kosumoth the Hungering",
		[119629] = "Lord Hel'Nurath",
		[16264] = "Winaestra <Hawkstrider Breeder>",
		[50484] = "Magistrix Nizara <Silvermoon City Quartermaster>",
		[16860] = "Jilanne",
		[16185] = "Anathos <Stable Master>",
		[109912] = "Captive Wyrmtongue <Reluctant 'Quartermaster'>",
		[91592] = "Forlorn Composer",
		[9543] = "Ribbly Screwspigot",
		[3951] = "Bhaldaran Ravenshade",
		[34303] = "Dagrun Ragehammer",	
		[3954] = "Dalria",
		[43630] = "Drek",
		[34601] = "Harlown Darkweave",
		[3958] = "Lardan",
		[43617] = "Lursa",
		[10052] = "Maluressian",
		[15131] = "Qeeju",
		[43634] = "Vorcha",
		[12962] = "Wik'Tar",
		[55072] = "Barum <Replica Armor Prizes>",
		[57983] = "Baruma <Replica Armor Prizes>",
		[55305] = "Carl Goodup <Balloon Vendor>",
		[85484] = "Chester <Vestments and Oddities>",
		[85519] = "Christoph VonFeasel <Grand Master Pet Tamer>",
		[56335] = "Daenrand Dawncrest <Heirloom Prizes>",
		[55103] = "Galissa Sundew <Fishing Prizes>",
		[14828] = "Gelvas Grimegate <Souvenir & Toy Prizes>",
		[26124] = "Midsummer Merchant", -- Horde
		[26123] = "Midsummer Supplier", -- Alliance
		[28194] = "Prince Tenris Mirkblood <The San'layn>",
		[67370] = "Jeremy Feasel <Master Pet Tamer>",
		[14846] = "Lhara <Pet & Mount Prizes>",
		[14847] = "Professor Thaddeus Palo <Darkmoon Cards>",
		[108785] = "Scarlet Quartermaster",
		[56069] = "Tatia Brine <Fishing Supplier>",
		[58336] = "Darkmoon Rabbit",
		[71992] = "Moonfang <Darkmoon Den Mother>",
		[122899] = "Death Metal Knight",
		[55278] = "Boomie Sparks <Fireworks>",
		[54473] = "Warpweaver Dushar <Transmogrifier>",
		[54442] = "Warpweaver Hashom <Transmogrifier>",
		[108715] = "Ol' Eary",
		[34382] = "Chapman <Day of the Dead Vendor>",
		[23872] = "Coren Direbrew",
		[23710] = "Belbi Quikswitch <Token Redeemer>", -- Alliance
		[24495] = "Blix Fixwidget <Token Redeemer>", -- Horde
		[23481] = "Keiran Donoghue <Sausage Vendor>", -- Alliance
		[23605] = "Bron <Sausage Vendor>", -- Horde
		[24468] = "Pol Amberstill <Ram Racing Apprentice>", -- Alliance
		[24510] = "Driz Tumblequick <Ram Racing Apprentice>", -- Horde 
		[117813] = "Pan the Kind Hand <Stable Master>",
		[120076] = "Treasure Master Iks'reeged",
		[121589]= "Thaumaturge Vashreen <Purveryor of Exquisite Furnishings>",
		[117799]= "Uthrok <Bowyer & Gunsmith>",
		[120898]= "Warmage Kath'leen <Legionfall Artificer>",
		[99976] = "Crusader Lord Dalfors",
		[100196] = "Eadric the Pure <Quartermaster>",
		[112401] = "Meridelle Lightspark <Logistics>",
		[112440] = "Jackson Watkins <Tirisgarde Quartermaster>",
		[103169] = "Uthel'nay",
		[105986] = "Kelsey Steelspark <Quartermaster>",
		[103792] = "Griftah <Amazing Amulets>",
		[99863] = "Jenri <Spymaster>",
		[112338] = "Caydori Brightstar <Purveyor of Rare Goods>",
		[99154] = "Mei Chele",
		[116621] = "Demissya Gladestrider <Illidari Provisioner's Assistant>",
		[112407] = "Falara Nightsong <Illidari Provisioner>",
		[100633] = "Death Hunter Moorgoth <Hunters of Death>",
		[103693] = "Outfitter Reynolds <Unseen Path>",
		[100661] = "Pan the Kind Hand <Stable Master>",
		[112318] = "Flamesmith Lanying <Earthen Ring Quartermaster>",
		[103004] = "Puzzlemaster Lo <The Earthen Ring>",
		[114064] = "Snowfang",
		[112392] = "Quartermaster Durnolf",
		[93550] = "Quartermaster Ozorg <Rare Goods Vendor>",
		[98685] = "Cupri <Timewalking Vendor>",
		[27667] = "Anwehu <Weapons & Armorsmith>",
		[18525] = "G'eras",
		[99574] = "Slyhoof the Shameless Shaman <Used Totem Vendor>",
		[93975] = "Leyweaver Yaphisteia",
		[115887] = "Trinket",
		[98367] = "Tigrid the Charmer <Enchantress>",
		[90866] = "Tinkmaster Overspark <Chief Architect of Gnomish Engineering>",
		[93974] = "Leyweaver Erenyi",
		[115710] = "Chief Telemancer Oculeth",
		[112064] = "Dolse Shimmersong <Souvenirs>",
		[113843] = "Kieule <Souvenirs>",
		[112059] = "Sasunne Dameuse <Souvenirs>",
		[93971] = "Leyweaver Inondra",
		[93979] = "Leyweaver Jorjana",
		[28944] = "Abra Cadabra",
		[29512] = "Ainderu Summerleaf <Mooncloth Tailoring Specialist>",
		[29628] = "Angelique Butler <First Aid Supplies>",
		[28990] = "Anthony Durain <Shield Merchant>",
		[31579] = "Arcanist Adurin <Legacy Justice Quartermaster>",
		[33964] = "Arcanist Firael <Legacy Justice Quartermaster>",
		[31580] = "Arcanist Ivrenne <Legacy Justice Quartermaster>",
		[35494] = "Arcanist Miluria <Legacy Justice Quartermaster>",
		[37942] = "Arcanist Uovril <Legacy Justice Quartermaster>",
		[32287] = "Archmage Alvareaux <Kirin Tor Quartermaster>",
		[98690] = "Auzin <Timewalking Vendor>",
		[37941] = "Magister Arlan <Legacy Justice Quartermaster>",
		[31581] = "Magister Brasael <Legacy Justice Quartermaster>",
		[33963] = "Magister Sarien <Legacy Justice Quartermaster>",
		[31582] = "Magistrix Lambriesse <Legacy Justice Quartermaster>",
		[35495] = "Magistrix Vesara <Legacy Justice Quartermaster>",
		[32216] = "Mei Francis <Exotic Mounts>",
		[28951] = "Breanni <Pet Supplies>",
		[29716] = "Clockwork Assistant <Jepetto's Companion>",
		[106887] = "Cravitz Lorent <Shady Book Dealer>",
		[29499] = "Bartram Haller <Dagger & Fist Weapon Merchant>",
		[32515] = "Braeg Stoutbeard <Fur & Leather Trader>",
		[29523] = "Bragund Brightlink <Mail Armor Merchant>",
		[29537] = "Darahir <Reagents & Magical Goods>",
		[31032] = "Derek Odds <Cooking Supplies>",
		[34252] = "Dubin Clay <Plate Armor Merchant>",
		[98969] = "Stalriss Dawnrunner <Leatherworking Trainer>",
		[92265] = "Urael <Nal'ryssa's Minion>",
		[96483] = "Jepetto Joybuzz <Toymaker>",
		[31031] = "Misensi <Cooking Supplies>",
		[33595] = "Mera Mistrunner <Cooking Supplies>",
		[33307] = "Corporal Arthur Flew <Stormwind Quartermaster>",
		[33310] = "Derrick Brindlebeard <Ironforge Quartermaster>",
		[33556] = "Doru Thunderhorn <Thunder Bluff Quartermaster>",
		[33555] = "Eliza Killian <Undercity Quartermaster>",
		[33553] = "Freka Bloodaxe <Orgrimmar Quartermaster>",
		[33657] = "Irisee <Exodar Quartermaster>",
		[33650] = "Rillie Spindlenut <Gnomeregan Quartermaster>",
		[33653] = "Rook Hawkfist <Darnassus Quartermaster>",
		[33554] = "Samamba <Sen'jin Quartermaster>",
		[33557] = "Trellis Morningsun <Silvermoon Quartermaster>",
		[33853] = "Broxel Goldgrasp <Souvenirs>",
		[34885] = "Dame Evniki Kapsalis <Crusader's Quartermaster>",
		[32538] = "Duchess Mynx <Ebon Blade Quartermaster>",
		[34881] = "Hiren Loresong <Silver Covenant Quartermaster>",
		[35578] = "Valiant Bressia <Triumphant Armor Vendor>",
		[35577] = "Valiant Laradia <Triumphant Armor Vendor>",
		[34772] = "Vasarin Redmorn <Sunreavers Quartermaster>",
		[30431] = "Veteran Crusader Aliocha Segard <Argent Crusade Quartermaster>",
		[35573] = "Arcanist Asarina <Legacy Justice Quartermaster>",
		[35579] = "Aspirant Forudir <Triumphant Armor Vendor>",
		[35580] = "Aspirant Naradiel <Triumphant Armor Vendor>",
		[35576] = "Champion Faesrol <Triumphant Armor Vendor>",
		[35575] = "Champion Isimode <Triumphant Armor Vendor>",
		[35574] = "Magistrix Iruvia <Legacy Justice Quartermaster>",
		[68000] = "Hiren Loresong <Kirin Tor Offensive Quartermaster>",
		[70535] = "Teng of the Flying Daggers <Shado-Pan Assault Quartermaster>",
		[67672] = "Vasarin Redmorn <Sunreaver Onslaught Quartermaster>",
		[3636] = "Deviate Ravager / Deviate Guardian",
		[3840] = "Druid of the Fang",
		[3872] = "Deathsworn Captain (Rare)",
		[5768] = "Ebru <Disciple of Naralex>",
		[5711] = "Ogom the Wretched",
		[5912] = "Deviate Faerie Dragon (Rare)",
		[6228] = "Dark Iron Ambassador (Rare)",
		[8923] = "Panzor the Invincible (Rare)",
		[9027] = "Gorosh the Dervish (Random)",
		[9028] = "Grizzle (Random)",
		[9029] = "Eviscerator (Random)",
		[9030] = "Ok'thor the Breaker (Random)",
		[9031] = "Anub'shiah (Random)",
		[9032] = "Hedrum the Creeper (Random)",
		[9042] = "Verek",
		[9257] = "Scarshield Warlock (Don't Kill!)",
		[10263] = "Burning Felguard (Portals - Rare) (Infinitely Farmable)",
		[9217] = "Spirestone Lord Magus (Rare)",
		[9218] = "Spirestone Battle Lord (Rare)",
		[9219] = "Spirestone Butcher (Rare)",
		[9259] = "Firebrand Grunt (Leatherworking)",
		[9260] = "Firebrand Legionnaire (Leatherworking)",
		[9264] = "Firebrand Pyromancer (Tailoring)",
		[9596] = "Bannok Grimaxe (Rare)",
		[9718] = "Ghok Bashguud (Rare)",
		[10559] = "Lady Vespia",
		[10076] = "High Priestess of Thaurissan",
		[10080] = "Sandarr Dunereaver (Rare)",
		[10081] = "Dustwraith (Rare)",
		[10082] = "Zerillis (Rare)",
		[10376] = "Crystal Fang (Rare)",
		[10393] = "Skul (Rare)",
		[10809] = "Stonespine (Rare)",
		[11143] = "Postmaster Malown (Summonable - Mailboxes)",
		[11467] = "Tsu'zee (Rare)",
		[12237] = "Meshlok the Harvester (Rare)",
		[14371] = "Shen'dralar Provisioner <House of Shen'dralar>",
		[14506] = "Lord Hel'nurath*",
		[101097] = "Calydus",
		[112434] = "Gigi Gigavoid <Black Harvest Quartermaster>",
		[112323] = "Amurra Thistledew <Proprietor>",
		[15385] = "Colonel Zerran + Captains",
		[15511] = "Lord Kri (Killed Last)",
		[15543] = "Princess Yauj (Killed Last)",
		[15544] = "Vem (Killed Last)",
		[17225] = "Nightbane",
		[17521] = "The Big Bad Wolf (Random)",
		[17534] = "Romulo & Julianne (Random)",
		[17711] = "Doomwalker",
		[18168] = "Wizard of Oz - The Crone (Random)",
		[18314] = "Nexus Stalker",
		[18422] = "Sunseeker Botanist",
		[18478] = "Avatar of the Martyred (Slowly DPS Exarch to 30%)",
		[18497] = "Auchenai Monk",
		[18728] = "Doom Lord Kazzak",
		[18830] = "Cabal Fanatic",
		[18672] = "Thomas Yance (Vendor - Southshore)",
		[19168] = "Sunseeker Astromage",
		[25740] = "Ahune <The Frost Lord>",
		[20869] = "Arcatraz Sentinel",
		[20900] = "Unchained Doombringer",
		[28132] = "Don Carlos (Neutral - Wanders on Road)",
		[59369] = "Doctor Theolen Krastinov (Rare)",
		[68220] = "Gastropod (Try not to die...)",
		[69944] = "Sand Elemental",
		[113621] = "Endgineer Omegaplugg -- READ TOOLTIP",
		[114895] = "Nightbane (Speed Run)",	
		[16388] = "Koren - Livery Stables",
		[18255] = "Mage Darius - Just outside in Deadwind Pass",
		[16181] = "Rokad the Ravager (Random - Repeatable - Don't kill other bosses.)",
		[16179] = "Hyakiss the Lurker(Random - Repeatable - Don't kill other bosses.)",
		[16180] = "Shadikith the Glider (Random - Repeatable - Don't kill other bosses.)",
		[92636] = "The Night Haunter",
		[91632] = "Remington Brode <Traveling Lumberjack>",
		[72156] = "Borrok the Devourer (Feed 10 Ogres)",
		[5809] = "Sergeant Curtis",
		[5822] = "Felweaver Scornn",
		[5823] = "Death Flayer",
		[5824] = "Captain Flat Tusk",
		[5826] = "Geolord Mottle",
		[3058] = "Arra'chea",
		[3068] = "Mazzranache",
		[5785] = "Sister Hatelash",
		[5786] = "Snagglespear",
		[5787] = "Enforcer Emilgund",
		[5807] = "The Rake",
		[43613] = "Doomsayer Wiserunner",
		[3270] = "Elder Mystic Razorsnout",
		[3295] = "Sludge Anomaly",
		[3398] = "Gesharahan",
		[3470] = "Rathorian",
		[3652] = "Trigore the Lasher",
		[3672] = "Boahn",
		[5828] = "Humar the Pridelord",
		[5830] = "Sister Rathtalon",
		[5831] = "Swiftmane",
		[5835] = "Foreman Grills",
		[5836] = "Engineer Whirleygig",
		[5837] = "Stonearm",
		[5838] = "Brokespear",
		[5841] = "Rocklance",
		[5842] = "Takk the Leaper",
		[5865] = "Dishu",
		[2598] = "Darbel Montrose",
		[2600] = "Singer",
		[2601] = "Foulbelly",
		[2602] = "Ruul Onestone",
		[2603] = "Kovork",
		[2604] = "Molok the Crusher",
		[2605] = "Zalas Witherbark",
		[2606] = "Nimar the Slayer",
		[2609] = "Geomancer Flintdagger",
		[2779] = "Prince Nazjak",
		[50337] = "Cackle",
		[50770] = "Zorn",
		[50804] = "Ripwing",
		[50865] = "Saurix",
		[50891] = "Boros",
		[50940] = "Swee",
		[51040] = "Snuffles",
		[51063] = "Phalanax",
		[51067] = "Glint",
		[2744] = "Shadowforge Commander",
		[2749] = "Barricade",
		[2751] = "War Golem",
		[2752] = "Rumbler",
		[2753] = "Barnabus",
		[2754] = "Anathemus",
		[2850] = "Broken Tooth",
		[2931] = "Zaricotl",
		[14224] = "7:XT",
		[50726] = "Kalixx",
		[50728] = "Deathstrike",
		[50731] = "Needlefang",
		[50838] = "Tabbs",
		[51000] = "Blackshell the Impenetrable",
		[51007] = "Serkett",
		[51018] = "Zormus",
		[51021] = "Vorticus",
		[7846] = "Teremus the Devourer",
		[8296] = "Mojo the Twisted",
		[8297] = "Magronos the Unyielding",
		[8298] = "Akubar the Seer",
		[8299] = "Spiteflayer",
		[8300] = "Ravage",
		[8301] = "Clack the Reaver",
		[8302] = "Deatheye",
		[8303] = "Grunter",
		[8304] = "Dreadscorn",
		[45257] = "Mordak Nightbender",
		[45258] = "Cassia the Slitherqueen",
		[45260] = "Blackleaf",
		[45262] = "Narixxus the Doombringer",
		[1531] = "Lost Soul",
		[1533] = "Tormented Spirit",
		[1910] = "Muad",
		[1911] = "Deeb",
		[1936] = "Farmer Solliden",
		[10356] = "Bayne",
		[10357] = "Ressan the Needler",
		[10358] = "Fellicent's Shade",
		[10359] = "Sri'skulk",
		[50763] = "Shadowstalker",
		[50803] = "Bonechewer",
		[50908] = "Nighthowl",
		[50930] = "Hibernus the Sleeper",
		[51044] = "Plague",
		[12431] = "Gorefang",
		[12433] = "Krethis the Shadowspinner",
		[46981] = "Nightlash",
		[46992] = "Berard the Moon-Crazed",
		[47003] = "Bolgaff",
		[47008] = "Fenwick Thatros",
		[47009] = "Aquarius the Unbound",
		[47012] = "Effritus",
		[47015] = "Lost Son of Arugal",
		[47023] = "Thule Ravenclaw",
		[50330] = "Kree",
		[50814] = "Corpsefeeder",
		[50949] = "Finn's Gambit",
		[51026] = "Gnath",
		[51037] = "Lost Gilnean Wardog",
		[1837] = "Scarlet Judge",
		[1838] = "Scarlet Interrogator",
		[1839] = "Scarlet High Clerist",
		[1841] = "Scarlet Executioner",
		[1847] = "Foulmane",
		[1848] = "Lord Maldazzar",
		[1849] = "Dreadwhisper",
		[1850] = "Putridius",
		[1851] = "The Husk",
		[1885] = "Scarlet Smith",
		[50345] = "Alit",
		[50778] = "Ironweb",
		[50809] = "Heress",
		[50906] = "Mutilax",
		[50922] = "Warg",
		[50931] = "Mange",
		[50937] = "Hamhide",
		[51029] = "Parasitus",
		[51031] = "Tracker",
		[51058] = "Aphis",
		[111122] = "Large Vile Slime",
		[1843] = "Foreman Jerris",
		[1844] = "Foreman Marcrid",
		[10817] = "Duggan Wildhammer",
		[10818] = "Death Knight Soulbearer",
		[10819] = "Baron Bloodbane",
		[10820] = "Duke Ragereaver",
		[10821] = "Hed'mush the Rotting",
		[10823] = "Zul'Brin Warpbranch",
		[10824] = "Death-Hunter Hawkspear",
		[10825] = "Gish the Unmoving",
		[10826] = "Lord Darkscythe",
		[10827] = "Deathspeaker Selendre",
		[10828] = "Lynnia Abbendis",
		[16184] = "Nerubian Overseer",
		[50775] = "Likk the Hunter",
		[50779] = "Sporeggon",
		[50813] = "Fene-mal",
		[50856] = "Snark",
		[50915] = "Snort",
		[50947] = "Varah",
		[51027] = "Spirocula",
		[51042] = "Bleakheart",
		[51053] = "Quirix",
		[2258] = "Maggarrak",
		[2452] = "Skhowl",
		[2453] = "Lo'Grosh",
		[14221] = "Gravis Slipknot",
		[14222] = "Araga",
		[14223] = "Cranky Benj",
		[14275] = "Tamra Stormpike",
		[14276] = "Scargil",
		[14277] = "Lady Zephris",
		[14278] = "Ro'Bark",
		[14279] = "Creepthess",
		[14280] = "Big Samras",
		[14281] = "Jimmy the Bleeder",
		[47010] = "Indigos",
		[50335] = "Alitus",
		[50765] = "Miasmiss",
		[50770] = "Zorn",
		[50818] = "The Dark Prowler",
		[50858] = "Dustwing",
		[50929] = "Little Bjorn",
		[50955] = "Carcinak",
		[50967] = "Craw the Ravager",
		[51022] = "Chordix",
		[51057] = "Weevil",
		[51076] = "Lopex",
		[8210] = "Razortalon",
		[8211] = "Old Cliff Jumper",
		[8212] = "The Reak",
		[8213] = "Ironback",
		[8214] = "Jalinde Summerdrake",
		[8215] = "Grimungous",
		[8216] = "Retherokk the Berserker",
		[8217] = "Mith'rethis the Enchanter",
		[8218] = "Witherheart the Stalker",
		[8219] = "Zul'arek Hatefowler",
		[107617] = "Ol' Muddle",
		[1119] = "Hammerspine",
		[1130] = "Bjarn",
		[1137] = "Edan the Howler",
		[1260] = "Great Father Arctikus",
		[8277] = "Rekk'tilac",
		[8278] = "Smoldar",
		[8279] = "Faulty War Golem",
		[8280] = "Shleipnarr",
		[8281] = "Scald",
		[8282] = "Highlord Mastrogonde",
		[8283] = "Slave Master Blackheart",
		[50846] = "Slavermaw",
		[50876] = "Avis",
		[50946] = "Hogzilla",
		[50948] = "Crystalback",
		[51002] = "Scorpoxx",
		[51010] = "Snips",
		[51048] = "Rexxus",
		[51066] = "Crystalfang",
		[8976] = "Hematos",
		[8978] = "Thauris Balgarr",
		[8979] = "Gruklash",
		[8981] = "Malfunctioning Reaver",
		[9602] = "Hahk'Zor",
		[9604] = "Gorgon'och",
		[10077] = "Deathmaw",
		[10078] = "Terrorspark",
		[10119] = "Volchan",
		[50357] = "Sunwing",
		[50361] = "Ornat",
		[50725] = "Azelisk",
		[50730] = "Venomspine",
		[50792] = "Chiaa",
		[50807] = "Catal",
		[50810] = "Favored of Isiset",
		[50839] = "Chromehound",
		[50842] = "Magmagan",
		[50855] = "Jaxx the Rabid",
		[51066] = "Crystalfang",
		[61] = "Thuros Lightfingers",
		[62] = "Gug Fatcandle",
		[79] = "Narg the Taskmaster",
		[99] = "Morgaine the Sly",
		[100] = "Gruff Swiftbite",
		[471] = "Mother Fang",
		[472] = "Fedfennel",
		[50752] = "Tarantis",
		[50916] = "Lamepaw the Whimperer",
		[50926] = "Grizzled Ben",
		[50942] = "Snoot the Rooter",
		[51014] = "Terrapis",
		[51077] = "Bushtail",
		[507] = "Fenros",
		[521] = "Lupos",
		[534] = "Nefaru",
		[574] = "Naraxis",
		[45739] = "The Unknown Soldier",
		[45740] = "Watcher Eva",
		[45771] = "Marus",
		[45785] = "Carved One",
		[45801] = "Eliza",
		[45811] = "Marina DeSirrus",
		[1398] = "Boss Galgosh",
		[1399] = "Magosh",
		[1425] = "Kubb",
		[2476] = "Gosh-Haldir",
		[14266] = "Shanda the Spinner",
		[14267] = "Emogg the Crusher",
		[14268] = "Lord Condar",
		[45369] = "Morick Darkbrew",
		[45380] = "Ashtail",
		[45384] = "Sagepaw",
		[45398] = "Grizlak",
		[45399] = "Optimo",
		[45401] = "Whitefin",
		[45402] = "Nix",
		[45404] = "Geoshaper Maren",
		[584] = "Kazon",
		[616] = "Chatter",
		[947] = "Rohh the Silent",
		[14269] = "Seeker Aqualon",
		[14270] = "Squiddic",
		[14271] = "Ribchaser",
		[14272] = "Snarlflare",
		[14273] = "Boulderheart",
		[52146] = "Chitter",
		[11383] = "High Priestess Hai'watna",
		[14487] = "Gluggl",
		[14488] = "Roloch",
		[51658] = "Mogh the Dead",
		[51661] = "Tsul'Kalu",
		[51662] = "Mahamba",
		[51663] = "Pogeyan",
		[763] = "Lost One Chieftain",
		[1063] = "Jade",
		[1106] = "Lost One Cook",
		[5348] = "Dreamwatcher Forktongue",
		[14445] = "Captain Wyrmak",
		[14446] = "Fingat",
		[14447] = "Gilmorian",
		[14448] = "Molt Thorn",
		[50738] = "Shimmerscale",
		[50790] = "Ionis",
		[50797] = "Yukiko",
		[50837] = "Kash",
		[50882] = "Chupacabros",
		[50886] = "Seawing",
		[50903] = "Orlix the Swamplord",
		[51052] = "Gib the Banana-Hoarder",
		[462] = "Vultros",
		[506] = "Sergeant Brashclaw",
		[519] = "Slark",
		[520] = "Brack",
		[572] = "Leprithus",
		[573] = "Foe Reaper 4000",
		[596] = "Brainwashed Noble",
		[599] = "Marisa du'Paige",
		[1424] = "Master Digger",
		[1112] = "Leech Widow",
		[1140] = "Razormaw Matriarch",
		[2090] = "Ma'ruk Wyrmscale",
		[2108] = "Garneg Charskull",
		[4604] = "Abigail Sawyer <Bow Merchant>",
		[10053] = "Anya Maulray <Stable Master>",
		[4573] = "Armand Cromwell <Fishing Trainer>",
		[8403] = "Jeremiah Payson <Cockroach Vendor>",
		[50304] = "Captain Donald Adams <Undercity Quartermaster>",
		[4589] = "Joseph Moore <Leatherworking Supplies>",
		[4558] = "Lauren Newcomb <Light Armor Merchant>",
		[4577] = "Millie Gregorian <Tailoring Supplies>",
		[10856] = "Argent Quartermaster Hasana <The Argent Dawn>",
		[3522] = "Constance Brisboise <Apprentice Clothier>",
		[12943] = "Werg Thickblade <Leatherworking Supplies>",
		[4731] = "Zachariah Post <Undead Horse Merchant>",
		[3552] = "Alexandre Lefevre <Leather Armor Merchant>",
		[3554] = "Andrea Boynton <Clothier>",
		[3556] = "Andrew Hilbert <Trade Supplies>",
		[9553] = "Nadia Vernon <Bowyer>",
		[3534] = "Wallace the Blind <Weaponsmith>",
		[14424] = "Mirelow",
		[14425] = "Gnawbone",
		[14433] = "Sludginn",
		[44224] = "Two-Toes",
		[44225] = "Rufus Darkshot",
		[44226] = "Sarltooth",
		[44227] = "Gazz the Loch-Hunter",
		[50964] = "Chops",
		[2162] = "Agal",
		[3535] = "Blackmoss the Fetid",
		[14428] = "Uruson",
		[14429] = "Grimmaw",
		[14430] = "Duskstalker",
		[14431] = "Fury Shelda",
		[14432] = "Threggil",
		[2172] = "Strider Clutchmother",
		[2175] = "Shadowclaw",
		[2184] = "Lady Moongazer",
		[2186] = "Carnivous the Breaker",
		[2191] = "Licillin",
		[2192] = "Firecaller Radison",
		[7015] = "Flagglemurk the Cruel",
		[7016] = "Lady Vespira",
		[7017] = "Lord Sinslayer",
		[3735] = "Apothecary Falthis",
		[3736] = "Darkslayer Mordenthal",
		[3773] = "Akkrilus",
		[3792] = "Terrowulf Packlord",
		[10639] = "Rorgish Jowl",
		[10640] = "Oakpaw",
		[10641] = "Branch Snapper",
		[10642] = "Eck'alom",
		[10644] = "Mist Howler",
		[10647] = "Prince Raze",
		[12037] = "Ursol'lok",
		[4132] = "Krkk'kx",
		[5933] = "Achellios the Banished",
		[5935] = "Ironeye the Invincible",
		[5937] = "Vile Sting",
		[14426] = "Harb Foulmountain",
		[14427] = "Gibblesnik",
		[50329] = "Rrakk",
		[50727] = "Strix the Barbed",
		[50741] = "Kaxx",
		[50748] = "Nyaj",
		[50785] = "Skyshadow",
		[50892] = "Cyn",
		[50952] = "Barnacle Jim",
		[51001] = "Venomclaw",
		[51008] = "The Barbed Horror",
		[4066] = "Nal'taszar",
		[5915] = "Brother Ravenoak",
		[5928] = "Sorrow Wing",
		[5930] = "Sister Riven",
		[5932] = "Taskmaster Whipfang",
		[50343] = "Quall",
		[50759] = "Iriss the Widow",
		[50786] = "Sparkwing",
		[50812] = "Arae",
		[50825] = "Feras",
		[50874] = "Tenok",
		[50884] = "Dustflight the Cowardly",
		[50895] = "Volux",
		[50986] = "Goldenback",
		[51062] = "Khep-Re",
		[11688] = "Cursed Centaur",
		[14225] = "Prince Kellen",
		[14226] = "Kaskk",
		[14227] = "Hissperak",
		[14228] = "Giggler",
		[14229] = "Accursed Slitherblade",
		[18241] = "Crusty",
		[5343] = "Lady Szallah",
		[5345] = "Diamond Head",
		[5346] = "Bloodroar the Stalker",
		[5347] = "Antilus the Soarer",
		[5349] = "Arash-ethis",
		[5350] = "Qirot",
		[5352] = "Old Grizzlegut",
		[5354] = "Gnarl Leafbrother",
		[5356] = "Snarler",
		[11447] = "Mushgog",
		[11497] = "The Razza",
		[11498] = "Skarr the Broken",
		[43488] = "Mordei the Earthrender",
		[54533] = "Prince Lakma",
		[4339] = "Brimgore",
		[4380] = "Darkmist Widow",
		[14230] = "Burgle Eye",
		[14231] = "Drogoth the Roamer",
		[14232] = "Dart",
		[14233] = "Ripscale",
		[14234] = "Hayoc",
		[14235] = "The Rot",
		[14236] = "Lord Angler",
		[14237] = "Oozeworm",
		[50342] = "Heronis",
		[50735] = "Blinkeye the Rattler",
		[50764] = "Paraliss",
		[50784] = "Anith",
		[50875] = "Nychus",
		[50901] = "Teromak",
		[50945] = "Scruff",
		[50957] = "Hugeclaw",
		[51061] = "Roth-Salam",
		[51069] = "Scintillex",
		[8199] = "Warleader Krazzilak",
		[8200] = "Jin'Zallah the Sandbringer",
		[8201] = "Omgorn the Lost",
		[8203] = "Kregg Keelhaul",
		[8204] = "Soriid the Devourer",
		[8205] = "Haarka the Ravenous",
		[8207] = "Emberwing",
		[39183] = "Scorpitar",
		[39185] = "Slaverjaw",
		[39186] = "Hellgazer",
		[44714] = "Fronkle the Disturbed",
		[44722] = "Twisted Reflection of Narain",
		[44750] = "Caliph Scorpidsting",
		[44759] = "Andre Firebeard",
		[44761] = "Aquementas the Unchained",
		[44767] = "Occulus the Corrupted",
		[47386] = "Ainamiss the Hive Queen",
		[47387] = "Harakiss the Infestor",
		[6118] = "Varo'then's Ghost",
		[6648] = "Antilos",
		[6649] = "Lady Sesspira",
		[6650] = "General Fangferror",
		[6651] = "Gatekeeper Rageroar",
		[8660] = "The Evalcharr",
		[13896] = "Scalebeard",
		[107477] = "N.U.T.Z.",
		[7104] = "Dessecus",
		[7137] = "Immolatus",
		[14339] = "Death Howl",
		[14340] = "Alshirr Banebreath",
		[14342] = "Ragepaw",
		[14343] = "Olm the Wise",
		[14344] = "Mongress",
		[14345] = "The Ongar",
		[50362] = "Blackbog the Fang",
		[50724] = "Spinecrawl",
		[50777] = "Needle",
		[50833] = "Duskcoat",
		[50864] = "Thicket",
		[50905] = "Cida",
		[50925] = "Grovepaw",
		[51017] = "Gezan",
		[51025] = "Dilennaa",
		[51046] = "Fidonis",
		[107595] = "Grimrot",
		[107596] = "Grimrot",
		[6581] = "Ravasaur Matriarch",
		[6582] = "Clutchmother Zavas",
		[6583] = "Gruff",
		[6584] = "King Mosh",
		[6585] = "Uhk'loc",
		[14471] = "Setis",
		[14472] = "Gretheer",
		[14473] = "Lapress",
		[14474] = "Zora",
		[14475] = "Rex Ashil",
		[14476] = "Krellack",
		[14477] = "Grubthor",
		[14478] = "Huricanian",
		[14479] = "Twilight Lord Everun",
		[50370] = "Karapax",
		[50737] = "Acroniss",
		[50742] = "Qem",
		[50743] = "Manax",
		[50744] = "Qu'rik",
		[50745] = "Losaj",
		[50746] = "Bornix the Burrower",
		[50897] = "Ffexk the Dunestalker",
		[51004] = "Toxx",
		[54533] = "Prince Lakma",
		[10196] = "General Colbatann",
		[10197] = "Mezzir the Howler",
		[10198] = "Kashoch the Reaver",
		[10199] = "Grizzle Snowpaw",
		[10200] = "Rak'shiri",
		[10202] = "Azurous",
		[10741] = "Sian-Rotam",
		[50346] = "Ronak",
		[50348] = "Norissis",
		[50353] = "Manas",
		[50788] = "Quetzl",
		[50819] = "Iceclaw",
		[50993] = "Gal'dorak",
		[50995] = "Bruiser",
		[50997] = "Bornak the Gorer",
		[51028] = "The Deep Tunneler",
		[51045] = "Arcanus",
		[3581] = "Sewer Beast",
		[16631] = "Andra <Clothier>",
		[16670] = "Eriden <Blacksmithing Supplies>",
		[16782] = "Yatheon <Engineering Supplies>",
		[16623] = "Zyandrel <Cloth Armor Merchant>",
		[16854] = "Eldinarcus",
		[16855] = "Tregla",
		[22062] = "Dr. Whitherlimb",
		[17591] = "Blood Elf Bandit",
		[18677] = "Mekthorg the Wild",
		[18678] = "Fulgorge",
		[18679] = "Vorakem Doomspeaker",
		[18680] = "Marticar",
		[18681] = "Coilfang Emissary",
		[18682] = "Bog Lurker",
		[18694] = "Collidus the Warp-Watcher",
		[18695] = "Ambassador Jerrikar",
		[18696] = "Kraator",
		[18690] = "Morcrush",
		[18692] = "Hemathion",
		[18693] = "Speaker Mar'grom",
		[22060] = "Fenissa the Assassin",
		[17144] = "Goretooth",
		[18683] = "Voidhunter Yar",
		[18684] = "Bro'Gaz the Clanless",
		[18685] = "Okrek",
		[18686] = "Doomsayer Jurim",
		[18689] = "Crippler",
		[21724] = "Hawkbane",
		[18697] = "Chief Engineer Lorthander",
		[18698] = "Ever-Core the Punisher",
		[20932] = "Nuramoc",
		[32357] = "Old Crystalbark",
		[32358] = "Fumblub Gearwind",
		[32361] = "Icehorn",
		[32400] = "Tukemuth",
		[16528] = "Provisioner Vredigar",
		[16268] = "Eralan <Poison Supplies>",
		[33711] = "Plagued Snapper",
		[32409] = "Crazed Indu'le Survivor",
		[32417] = "Scarlet Highlord Daion",
		[32422] = "Grocklar",
		[32429] = "Seething Hate",
		[32438] = "Syreian the Bonecarver",
		[38453] = "Arcturis",
		[32377] = "Perobas the Bloodthirster",
		[32386] = "Vigdis the War Maiden",
		[32398] = "King Ping",
		[32487] = "Putridus the Ancient",
		[32495] = "Hildana Deathstealer",
		[32501] = "High Thane Jorfus",
		[32481] = "Aotona",
		[32485] = "King Krush",
		[32517] = "Loque'nahak",
		[32491] = "Time-Lost Proto-Drake",
		[32500] = "Dirkee",
		[32630] = "Vyragosa",
		[35189] = "Skoll",
		[32447] = "Zul'drak Sentinel",
		[32471] = "Griegen",
		[32475] = "Terror Spinner",
		[33776] = "Gondria",
		[50053] = "Thartuk the Exile",
		[50056] = "Garr",
		[50057] = "Blazewing",
		[50058] = "Terrorpene",
		[54318] = "Ankha",
		[54319] = "Magria",
		[54320] = "Ban'thalos",
		[3253] = "Silithid Harvester",
		[5829] = "Snort the Heckler",
		[5832] = "Thunderstomp",
		[5834] = "Azzere the Skyblade",
		[5847] = "Heggin Stonewhisker",
		[5848] = "Malgin Barleybrew",
		[5849] = "Digger Flameforge",
		[5851] = "Captain Gerogg Hammertoe",
		[5859] = "Hagg Taurenbane",
		[5863] = "Geopriest Gukk'rok",
		[5864] = "Swinegart Spearhide",
		[49913] = "Lady La-La",
		[51079] = "Captain Foulwind",
		[50005] = "Poseidus",
		[50009] = "Mobus",
		[50050] = "Shok'sharak",
		[50051] = "Ghostcrawler",
		[50005] = "Poseidus",
		[50052] = "Burgy Blackheart",
		[51071] = "Captain Florence",
		[3868] = "Blood Seeker",
		[49822] = "Jadefang",
		[50059] = "Golgarok",
		[50060] = "Terborus",
		[50062] = "Aeonaxx",
		[50061] = "Xariona",
		[1552] = "Scale Belly",
		[2541] = "Lord Sakrasis",
		[14490] = "Rippa",
		[14491] = "Kurmokk",
		[14492] = "Verifonix",
		[108715] = "Ol' Eary",
		[14445] = "Captain Wyrmak",
		[12902] = "Lorgus Jett",
		[50085] = "Overlord Sunderfury",
		[50086] = "Tarvus the Vile",
		[50089] = "Julak-Doom",
		[50138] = "Karoma",
		[50159] = "Sambas",
		[50063] = "Akma'hat",
		[50064] = "Cyrus the Black",
		[50065] = "Armagedillo",
		[50154] = "Madexx - Brown",
		[51401] = "Madexx - Red",
		[51402] = "Madexx - Green",
		[51403] = "Madexx - Black",
		[51404] = "Madexx - Blue",
		[9736] = "Quartermaster Zigris",
		[10263] = "Burning Felguard",
		[10509] = "Jed Runewatcher",
		[56081] = "Optimistic Benj",
		[596] = "Brainwashed Noble",
		[599] = "Marisa du'Paige",
		[4425] = "Blind Hunter",
		[4842] = "Earthcaller Halmgar",
		[75590] = "Enormous Bullfrog (Rare)",
		[10558] = "Hearthsinger Forresten",
		[10820] = "Duke Ragereaver",
		[50747] = "Tix",
		[50815] = "Skarr",
		[50959] = "Karkin",
		[54321] = "Solix",
		[54322] = "Deth'tilac",
		[54323] = "Kirix",
		[54324] = "Skitterflame",
		[54338] = "Anthriss",
		[16179] = "Hyakiss the Lurker",
		[16180] = "Shadikith the Glider",
		[16181] = "Rokad the Ravager",
		[50338] = "Kor'nas Nightsavage",
		[50350] = "Morgrinn Crackfang",
		[50363] = "Krax'ik",
		[50750] = "Aethis",
		[50782] = "Sarnak",
		[50808] = "Urobi the Walker",
		[50823] = "Mister Ferocious",
		[51078] = "Ferdinand",
		[69768] = "Zandalari Warscout",
		[69769] = "Zandalari Warbringer",
		[69841] = "Zandalari Warbringer",
		[69842] = "Zandalari Warbringer",
		[70323] = "Krakkanon",
		[50339] = "Sulik'shor",
		[50351] = "Jonn-Dar",
		[50364] = "Nal'lak the Ripper",
		[50766] = "Sele'na",
		[50783] = "Salyin Warscout",
		[50811] = "Nasra Spothide",
		[50828] = "Bonobos",
		[51059] = "Blackhoof",
		[50332] = "Korda Torros",
		[50341] = "Borginn Darkfist",
		[50354] = "Havak",
		[50733] = "Ski'thik",
		[50769] = "Zai the Outcast",
		[50789] = "Nessos the Oracle",
		[50817] = "Ahone the Wanderer",
		[50831] = "Scritch",
		[69768] = "Zandalari Warscout",
		[69769] = "Zandalari Warbringer",
		[69841] = "Zandalari Warbringer",
		[69842] = "Zandalari Warbringer",
		[70323] = "Krakkanon",
		[50333] = "Lon the Bull",
		[50344] = "Norlaxx",
		[50355] = "Kah'tir",
		[50734] = "Lith'ik the Stalker",
		[50772] = "Eshelon",
		[50791] = "Siltriss the Sharpener",
		[50820] = "Yul Wildpaw",
		[50832] = "The Yowler",
		[69768] = "Zandalari Warscout",
		[69769] = "Zandalari Warbringer",
		[69841] = "Zandalari Warbringer",
		[69842] = "Zandalari Warbringer",
		[50336] = "Yorik Sharpeye",
		[50349] = "Kang the Soul Thief",
		[50359] = "Urgolax",
		[50749] = "Kal'tik the Blight",
		[50780] = "Sahn Tidehunter",
		[50806] = "Moldo One-Eye",
		[50822] = "Ai-Ran the Shifting Cloud",
		[50840] = "Major Nanners",
		[50843] = "Portent",
		[58474] = "Bloodtip",
		[58768] = "Cracklefang",
		[58769] = "Vicejaw",
		[58771] = "Quid",
		[58778] = "Aetha",
		[58817] = "Spirit of Lao-Fe",
		[58949] = "Bai'Jin the Butcher",
		[62880] = "Gochao the Ironfist",
		[62881] = "Gaohun the Soul-Severer",
		[63101] = "General Temuja",
		[63240] = "Shadowmaster Sydow",
		[63509] = "Wulon",
		[63510] = "Wulon",
		[63691] = "Huo-Shuang",
		[63695] = "Baolai the Immolator",
		[63977] = "Vyraxxis",
		[63978] = "Kri'chon",
		[50331] = "Go-Kan",
		[50340] = "Gaarn the Toxic",
		[50352] = "Qu'nas",
		[50388] = "Torik-Ethis",
		[50768] = "Cournith Waterstrider",
		[50787] = "Arness the Scale",
		[50816] = "Ruun Ghostpaw",
		[50830] = "Spriggin",
		[68317] = "Mavis Harms",
		[68318] = "Dalan Nightbreaker",
		[68319] = "Disha Fearwarden",
		[68320] = "Ubunti the Shade",
		[68321] = "Kar Warmaker",
		[68322] = "Muerta",
		[69768] = "Zandalari Warscout",
		[69769] = "Zandalari Warbringer",
		[70323] = "Krakkanon",
		[50334] = "Dak the Breaker",
		[50347] = "Karr the Darkener",
		[50356] = "Krol the Blade",
		[50739] = "Gar'lok",
		[50776] = "Nalash Verdantis",
		[50805] = "Omnis Grinlok",
		[50821] = "Ai-Li Skymirror",
		[50836] = "Ik-Ik the Nimble",
		[69768] = "Zandalari Warscout",
		[69769] = "Zandalari Warbringer",
		[69841] = "Zandalari Warbringer",
		[69842] = "Zandalari Warbringer",
		[62] = "Gug Fatcandle",
		[70126] = "Willy Wilder",
		[43720] = "\"Pokey\" Thornmantle",
		[50328] = "Fangor",
		[1132] = "Timber",
		[1260] = "Great Father Arctikus",
		[8503] = "Gibblewilt",
		[107431] = "Weaponized Rabbot",
		[1850] = "Putridius",
		[59369] = "Doctor Theolen Krastinov",
		[50358] = "Haywire Sunreaver Construct",
		[69099] = "Nalak",
		[69664] = "Mumta",
		[69996] = "Ku'lai the Skyclaw",
		[69997] = "Progenitus",
		[69998] = "Goda",
		[69999] = "God-Hulk Ramuk",
		[70000] = "Al'tabim the All-Seeing",
		[70001] = "Backbreaker Uru",
		[70002] = "Lu-Ban",
		[70003] = "Molthor",
		[70530] = "Ra'sha",
		[69161] = "Oondasta",
		[70096] = "War-God Dokah",
		[69843] = "Zao'cho",
		[70238] = "Unblinking Eye",
		[70243] = "Archritualist Kelada",
		[70249] = "Focused Eye",
		[70276] = "No'ku Stormsayer",
		[70429] = "Flesh'rok the Diseased",
		[70430] = "Rocky Horror",
		[70440] = "Monara",
		[50992] = "Gorok",
		[71665] = "Giant-Slayer Kul",
		[71721] = "Canyon Icemother",
		[72294] = "Cindermaw",
		[72364] = "Gorg'ak the Lava Guzzler",
		[74613] = "Broodmother Reeg'ak",
		[74971] = "Firefury Giant",
		[76914] = "Coldtusk",
		[76918] = "Primalist Mur'og",
		[77513] = "Coldstomp the Griever",
		[77519] = "Giantbane",
		[77526] = "Scout Goreseeker",
		[77527] = "The Beater",
		[78128] = "Gronnstalker Dawarn",
		[78134] = "Pathfinder Jalog",
		[78144] = "Giantslayer Kimla",
		[78150] = "Beastcarver Saramor",
		[78151] = "Huntmaster Kuang",
		[78169] = "Cloudspeaker Daber",
		[78265] = "The Bone Crawler",
		[78606] = "Pale Fishmonger",
		[78621] = "Cyclonic Fury",
		[78867] = "Breathless",
		[79104] = "Ug'lok the Frozen",
		[79145] = "Yaga the Scarred",
		[80190] = "Gruuk",
		[80235] = "Gurun",
		[80242] = "Chillfang",
		[80312] = "Grutush the Pillager",
		[81001] = "Nok-Karosh",
		[82536] = "Gorivax",
		[82614] = "Moltnoma",
		[82616] = "Jabberjaw",
		[82617] = "Slogtusk the Corpse-Eater",
		[82618] = "Tor'goroth",
		[82620] = "Son of Goramal",
		[84374] = "Kaga the Ironbender",
		[84376] = "Earthshaker Holar",
		[84378] = "Ak'ox the Slaughterer",
		[84392] = "Ragore Driftstalker",
		[87348] = "Hoarfrost",
		[87351] = "Mother of Goren",
		[87352] = "Gibblette the Cowardly",
		[87356] = "Vrok the Ancient",
		[87357] = "Valkor",
		[87600] = "Jaluk the Pacifist",
		[87622] = "Ogom the Mangler",
		[80398] = "Keravnos",
		[89675] = "Commander Org'mok",
		[90024] = "Sergeant Mor'grak",
		[90094] = "Harbormaster Korak",
		[90122] = "Zoug the Heavy",
		[90429] = "Imp-Master Valessa",
		[90434] = "Ceraxas",
		[90437] = "Jax'zor",
		[90438] = "Lady Oran",
		[90442] = "Mistress Thavra",
		[90519] = "Cindral the Wildfire",
		[90777] = "High Priest Ikzan",
		[90782] = "Rasthe",
		[90884] = "Bilkor the Thrower",
		[90885] = "Rogond the Tracker",
		[90887] = "Dorg the Bloody",
		[90888] = "Drivnul",
		[90936] = "Bloodhunter Zulk",
		[91009] = "Putre'thar",
		[91087] = "Zeter'el",
		[91093] = "Bramblefell",
		[91098] = "Felspark",
		[91227] = "Remnant of the Blood Moon",
		[91232] = "Commander Krag'goth",
		[91243] = "Tho'gar Gorefist",
		[91374] = "Podlord Wakkawam",
		[91695] = "Grand Warlock Nethekurse",
		[91727] = "Executor Riloth",
		[91871] = "Argosh the Destroyer",
		[92197] = "Relgor",
		[92274] = "Painmistress Selora",
		[92408] = "Xanzith the Everlasting",
		[92411] = "Overlord Ma'gruth",
		[92429] = "Broodlord Ixkor",
		[92451] = "Varyx the Damned",
		[92465] = "The Blackfang",
		[92495] = "Soulslicer",
		[92508] = "Gloomtalon",
		[92517] = "Krell the Serene",
		[92552] = "Belgork",
		[92574] = "Thromma the Gutslicer",
		[92606] = "Sylissa",
		[92627] = "Rendrak - READ DESCRIPTION",
		[92645] = "The Night Haunter",
		[92647] = "Felsmith Damorka",
		[92657] = "Bleeding Hollow Horror",
		[92694] = "The Goreclaw",
		[92766] = "Akrrilo",
		[92817] = "Rendarr",
		[92819] = "Eyepiercer",
		[92887] = "Steelsnout",
		[92941] = "Gorabosh",
		[92977] = "The Iron Houndmaster",
		[93001] = "Szirek the Twisted",
		[93002] = "Magwia",
		[93028] = "Driss Vile",
		[93057] = "Grannok",
		[93076] = "Captain Ironbeard",
		[93125] = "Glub'glok",
		[93168] = "Felbore",
		[93236] = "Shadowthrash",
		[93264] = "Captain Grok'mar",
		[93279] = "Kris'kar the Unredeemed",
		[95044] = "Terrorfist",
		[95053] = "Deathtalon",
		[95054] = "Vengeance",
		[95056] = "Doomroller",
		[96235] = "Xemirkol",
		[98283] = "Drakum",
		[98284] = "Gondar",
		[98285] = "Smashum Grabb",
		[98408] = "Fel Overseer Mudlump",
		[51015] = "Silthide",
		[77529] = "Yazheera the Incinerator",
		[77561] = "Dr. Gloom",
		[77614] = "Frenzied Golem",
		[77620] = "Cro Fleshrender",
		[77626] = "Hen-Mother Hami",
		[77634] = "Taladorantula",
		[77664] = "Aarko",
		[77715] = "Hammertooth",
		[77719] = "Glimmerwing",
		[77741] = "Ra'kahn",
		[77750] = "Kaavu the Crimson Claw",
		[77776] = "Wandering Vindicator",
		[77784] = "Lo'marg Jawcrusher",
		[77795] = "Echo of Murmur",
		[77828] = "Echo of Murmur",
		[78710] = "Kharazos the Triumphant",
		[78713] = "Galzomar",
		[78715] = "Sikthiss, Maiden of Slaughter",
		[78872] = "Klikixx",
		[79334] = "No'losh",
		[79485] = "Talonpriest Zorkra",
		[79543] = "Shirzir",
		[80204] = "Felbark",
		[80471] = "Gennadian",
		[80524] = "Underseer Bloodmane",
		[82920] = "Lord Korinak",
		[82922] = "Xothear, the Destroyer",
		[82930] = "Shadowflame Terrorwalker",
		[82942] = "Lady Demlash",
		[82988] = "Kurlosh Doomfang",
		[82992] = "Felfire Consort",
		[82998] = "Matron of Sin",
		[83008] = "Haakun the All-Consuming",
		[83019] = "Gug'tol",
		[85572] = "Grrbrrgle",
		[86549] = "Steeltusk",
		[87597] = "Bombardier Gu'gok",
		[87668] = "Orumo the Observer",
		[88043] = "Avatar of Socrethar",
		[88071] = "Strategist Ankor",
		[88072] = "Archmagus Tekar",
		[88083] = "Soulbinder Naylana",
		[88436] = "Vigilant Paarthos",
		[88494] = "Legion Vanguard",
		[50883] = "Pathrunner",
		[72362] = "Ku'targ the Voidseer",
		[72537] = "Leaf-Reader Kurri",
		[72606] = "Rockhoof",
		[74206] = "Killmaw",
		[75071] = "Mother Om'ra",
		[75434] = "Windfang Matriarch",
		[75435] = "Yggdrel",
		[75482] = "Veloss",
		[75492] = "Venomshade",
		[76380] = "Gorum",
		[77085] = "Dark Emanation",
		[77140] = "Amaukwa",
		[77310] = "Mad \"King\" Sporeon",
		[79524] = "Hypnocroak",
		[79686] = "Silverleaf Ancient",
		[79692] = "Silverleaf Ancient",
		[79693] = "Silverleaf Ancient",
		[81406] = "Bahameye",
		[81639] = "Brambleking Fili",
		[82207] = "Faebright",
		[82268] = "Darkmaster Go'vid",
		[82326] = "Ba'ruun",
		[82362] = "Morva Soultwister",
		[82374] = "Rai'vosh",
		[82411] = "Darktalon",
		[82415] = "Shinri",
		[82676] = "Enavra",
		[82742] = "Enavra",
		[83385] = "Voidseer Kalurg",
		[83553] = "Insha'tar",
		[84911] = "Demidos",
		[84925] = "Quartermaster Hershak",
		[85001] = "Master Sergeant Milgra",
		[85029] = "Shadowspeaker Niir",
		[85121] = "Lady Temptessa",
		[85451] = "Malgosh Shadowkeeper",
		[85555] = "Nagidna",
		[85568] = "Avalanche",
		[85837] = "Slivermaw",
		[86213] = "Aqualir",
		[86689] = "Sneevel",
		[79938] = "Shadowbark",
		[80372] = "Echidna",
		[80614] = "Blade-Dancer Aeryx",
		[82050] = "Varasha",
		[82247] = "Nas Dunberlin",
		[83990] = "Solar Magnifier",
		[84417] = "Mutafen",
		[84775] = "Tesska the Broken",
		[84805] = "Stonespite",
		[84807] = "Durkath Steelmaw",
		[84810] = "Kalos the Bloodbathed",
		[84833] = "Sangrikass",
		[84836] = "Talonbreaker",
		[84838] = "Poisonmaster Bortusk",
		[84856] = "Blightglow",
		[84872] = "Oskiira the Vengeful",
		[84887] = "Betsi Boombasket",
		[84890] = "Festerbloom",
		[84912] = "Sunderthorn",
		[84951] = "Gobblefin",
		[84955] = "Jiasska the Sporegorger",
		[85026] = "Soul-Twister Torek",
		[85036] = "Formless Nightmare",
		[85037] = "Kenos the Unraveler",
		[85078] = "Voidreaver Urnae",
		[85504] = "Rotcap",
		[85520] = "Swarmleaf",
		[86621] = "Morphed Sentient",
		[86724] = "Hermit Palefur",
		[86978] = "Gaze",
		[87019] = "Gluttonous Giant",
		[87026] = "Mecha Plunderer",
		[87027] = "Shadow Hulk",
		[87029] = "Giga Sentinel",
		[50985] = "Poundfist",
		[75207] = "Biolante",
		[76473] = "Mother Araneae",
		[77093] = "Roardan the Sky Terror",
		[78260] = "King Slime",
		[78269] = "Gnarljaw",
		[79629] = "Stomper Kreego",
		[80371] = "Typhon",
		[80725] = "Sulfurious",
		[80785] = "Fungal Praetorian",
		[80868] = "Glut",
		[81038] = "Gelgor of the Blue Flame",
		[81528] = "Crater Lord Igneous",
		[81529] = "Dessicus of the Dead Pools",
		[81537] = "Khargax the Devourer",
		[81540] = "Erosian the Violent",
		[81548] = "Charl Doomwing",
		[82058] = "Depthroot",
		[82085] = "Bashiok",
		[82311] = "Char the Burning",
		[83522] = "Hive Queen Skrikka",
		[84406] = "Mandrakor",
		[84431] = "Greldrok the Cunning",
		[85250] = "Fossilwood the Petrified",
		[85264] = "Rolkor",
		[85907] = "Berthora",
		[85970] = "Riptar",
		[86137] = "Sunclaw",
		[86257] = "Basten",
		[86258] = "Nultra",
		[86259] = "Valstil",
		[86266] = "Venolasix",
		[86268] = "Alkali",
		[86410] = "Sylldross",
		[86520] = "Stompalupagus",
		[86562] = "Maniacal Madgard",
		[86566] = "Defector Dazgo",
		[86571] = "Durp the Hated",
		[86574] = "Inventor Blammo",
		[86577] = "Horgg",
		[86579] = "Blademaster Ro'gor",
		[86582] = "Morgo Kain",
		[88580] = "Firestarter Grash",
		[88582] = "Swift Onyx Flayer",
		[88583] = "Grove Warden Yal",
		[88586] = "Mogamago",
		[88672] = "Hunter Bal'ra",
		[50981] = "Luk'hok",
		[50990] = "Nakk the Thunderer",
		[78161] = "Hyperious",
		[79024] = "Warmaster Blugthol",
		[79725] = "Captain Ironbeard",
		[80057] = "Soulfang",
		[80122] = "Gaz'orda",
		[80370] = "Lernaea",
		[82486] = "Explorer Nozzand",
		[82755] = "Redclaw the Feral",
		[82758] = "Greatfeather",
		[82764] = "Gar'lua",
		[82778] = "Gnarlhoof the Rabid",
		[82826] = "Berserk T-300 Series Mark II",
		[82899] = "Ancient Blademaster",
		[82912] = "Grizzlemaw",
		[82975] = "Fangler",
		[83401] = "Netherspawn",
		[83409] = "Ophiis",
		[83428] = "Windcaller Korast",
		[83483] = "Flinthide",
		[83509] = "Gorepetal",
		[83526] = "Ru'klaa",
		[83542] = "Sean Whitesea",
		[83591] = "Tura'aka",
		[83603] = "Hunter Blacktooth",
		[83634] = "Scout Pokhar",
		[83643] = "Malroc Stonesunder",
		[83680] = "Outrider Duretha",
		[84263] = "Graveltooth",
		[84435] = "Mr. Pinchy Sr.",
		[86729] = "Direhoof",
		[86732] = "Bergruu",
		[86743] = "Dekorhan",
		[86750] = "Thek'talon",
		[86771] = "Gagrog the Brutal",
		[86774] = "Aogexon",
		[86835] = "Xelganak",
		[86959] = "Karosh Blackwind",
		[87234] = "Brutag Grimblade",
		[87239] = "Krahl Deadeye",
		[87344] = "Gortag Steelgrip",
		[87647] = "Aogexon",
		[87660] = "Dekorhan",
		[87661] = "Bergruu",
		[87666] = "Mu'gra",
		[87788] = "Durg Spinecrusher",
		[87837] = "Bonebreaker",
		[87846] = "Pit Slayer",
		[88208] = "Pit Beast",
		[88210] = "Krud the Eviscerator",
		[88951] = "Vileclaw",
		[98198] = "Rukdug",
		[98199] = "Pugg",
		[98200] = "Guk",
		[71864] = "Spelurk",
		[71919] = "Zhu-Gon the Sour",
		[72045] = "Chelon",
		[72048] = "Rattleskew",
		[72049] = "Cranegnasher",
		[72193] = "Karkanos",
		[72245] = "Zesqua",
		[72769] = "Spirit of Jadefire",
		[72775] = "Bufo",
		[72808] = "Tsavo'ka",
		[72909] = "Gu'chi the Swarmbringer",
		[72970] = "Golganarr",
		[73157] = "Rock Moss",
		[73158] = "Emerald Gander",
		[73160] = "Ironfur Steelhorn",
		[73161] = "Great Turtle Furyshell",
		[73163] = "Imperial Python",
		[73166] = "Monstrous Spineclaw",
		[73167] = "Huolon",
		[73169] = "Jakur of Ordon",
		[73170] = "Watcher Osu",
		[73171] = "Champion of the Black Flame",
		[73172] = "Flintlord Gairan",
		[73173] = "Urdur the Cauterizer",
		[73174] = "Archiereus of Flame",
		[73175] = "Cinderfall",
		[73277] = "Leafmender",
		[73279] = "Evermaw",
		[73281] = "Dread Ship Vazuvius",
		[73282] = "Garnia",
		[73293] = "Whizzig",
		[73666] = "Archiereus of Flame",
		[73704] = "Stinkbraid",
		[73854] = "Cranegnasher",
		[82876] = "Grand Marshal Tremblade",
		[82877] = "High Warlord Volrath",
		[82878] = "Marshal Gabriel",
		[82880] = "Marshal Karsh Stormforge",
		[82882] = "General Aevd",
		[82883] = "Warlord Noktyn",
		[83683] = "Mandragoraster",
		[83691] = "Panthora",
		[83713] = "Titarus",
		[83819] = "Brickhouse",
		[84110] = "Korthall Soulgorger",
		[84196] = "Web-wrapped Soldier",
		[84465] = "Leaping Gorger",
		[84746] = "Captured Gor'vosh Stoneshaper",
		[84854] = "Slippery Slime",
		[84875] = "Ancient Inferno",
		[84893] = "Goregore",
		[84904] = "Oraggro",
		[84926] = "Burning Power",
		[85763] = "Cursed Ravager",
		[85765] = "Cursed Kaliri",
		[85766] = "Cursed Sharptalon",
		[85767] = "Cursed Harbinger",
		[85771] = "Elder Darkweaver Kath",
		[87362] = "Gibby",
		[91921] = "Wyrmple",
		[94113] = "Rukmaz",
		[96323] = "Arachnis",
		[77081] = "The Lanticore",
		[89016] = "Ravyn-Drath",
		[89650] = "Valiyaka the Stormbringer",
		[89816] = "Golza the Iron Fin",
		[89846] = "Captain Volo'ren",
		[89850] = "The Oracle",
		[89865] = "Mrrgrl the Tide Reaver",
		[89884] = "Flog the Captain-Eater",
		[90057] = "Daggerbeak",
		[90164] = "Warbringer Mox'na",
		[90173] = "Arcana Stalker",
		[90217] = "Normantis the Deposed",
		[90244] = "Arcavellus",
		[90505] = "Syphonus",
		[90803] = "Infernal Lord",
		[90901] = "Pridelord Meowl",
		[91100] = "Brogozog",
		[91113] = "Tide Behemoth",
		[91114] = "Tide Behemoth",
		[91115] = "Tide Behemoth",
		[91187] = "Beacher",
		[91289] = "Cailyn Paledoom",
		[91579] = "Doomlord Kazrok",
		[93622] = "Mortiferous",
		[99846] = "Raging Earth",
		[99886] = "Pacified Earth",
		[101596] = "Charfeather",
		[102064] = "Torrentius",
		[102075] = "Withered J'im",
		[103975] = "Jade Darkhaven",
		[105938] = "Felwing",
		[106990] = "Chief Bitterbrine",
		[107105] = "Broodmother Lizax",
		[107113] = "Vorthax",
		[107127] = "Brawlgoth",
		[107136] = "Houndmaster Stroxis",
		[107169] = "Horux",
		[107170] = "Zorux",
		[107266] = "Commander Soraax",
		[107269] = "Inquisitor Tivos",
		[107327] = "Bilebrain",
		[107657] = "Arcanist Shal'iman",
		[108136] = "The Muscle",
		[108174] = "Bilgerat",
		[108255] = "Coura, Mistress of Arcana",
		[108678] = "Shar'thos",
		[108829] = "Levantus",
		[109331] = "Calamir",
		[109504] = "Ragemaw",
		[109575] = "Valakar the Thirsty",
		[109584] = "Fjordun",
		[109594] = "Stormfeather",
		[109620] = "The Whisperer",
		[109630] = "Immolian",
		[109641] = "Arcanor Prime",
		[109653] = "Marblub the Massive",
		[109677] = "Chief Treasurer Jabrill",
		[109702] = "Deepclaw",
		[110824] = "Tideclaw",
		[111434] = "Sea King Tidross",
		[111939] = "Lysanis Shadesoul",
		[112636] = "Sinister Leyrunner",
		[112637] = "Devious Sunrunner",
		[90139] = "Inquisitor Ernstenbok",
		[91529] = "Glimar Ironfist",
		[91780] = "Mother Clacker",
		[91795] = "Stormwing Matriarch",
		[91803] = "Fathnyr",
		[91874] = "Bladesquall",
		[91892] = "Thane Irglov the Merciless",
		[92152] = "Whitewater Typhoon",
		[92590] = "Hook",
		[92591] = "Sinker",
		[92599] = "Bloodstalker Alpha",
		[92604] = "Champion Elodie",
		[92609] = "Tracker Jack",
		[92611] = "Ambusher Daggerfang",
		[92613] = "Priestess Liza",
		[92626] = "Deathguard Adams",
		[92631] = "Dark Ranger Jess",
		[92633] = "Assassin Huwe",
		[92634] = "Apothecary Perez",
		[92682] = "Helmouth Raider",
		[92685] = "Captain Brvet",
		[92703] = "Helmouth Raider",
		[92751] = "Ivory Sentinel",
		[92763] = "The Nameless King",
		[92951] = "Houndmaster Ely",
		[93166] = "Tiptog the Lost",
		[93371] = "Mordvigbjorn",
		[93401] = "Urgev the Flayer",
		[94313] = "Daniel \"Boomer\" Vorick",
		[94347] = "Dread-Rider Cortis",
		[94413] = "Isel the Hammer",
		[98188] = "Egyl the Enduring",
		[98268] = "Tarben",
		[98421] = "Kottr Vondyr",
		[98503] = "Grrvrgull the Conqueror",
		[99886] = "Pacified Earth",
		[100223] = "Vrykul Earthshaper Spirit",
		[100224] = "Vrykul Earthmaiden Spirit",
		[107023] = "Nithogg",
		[107487] = "Starbuck",
		[107544] = "Nithogg",
		[107926] = "Hannval the Butcher",
		[108790] = "Den Mother Ylva",
		[108822] = "Huntress Estrid",
		[108823] = "Halfdan",
		[108827] = "Fjorlag, the Grave's Chill",
		[108885] = "Aegir Wavecrusher",
		[109015] = "Lagertha",
		[109113] = "Boulderfall, the Eroded",
		[109195] = "Soulbinder Halldora",
		[109317] = "Rulf Bonesnapper",
		[109318] = "Runeseer Sigvid",
		[109994] = "Stormtalon",
		[110363] = "Roteye",
		[111463] = "Bulvinkel",
		[92117] = "Gorebeak,",
		[92180] = "Seersei",
		[92423] = "Theryssia",
		[92965] = "Darkshade",
		[93030] = "Ironbranch",
		[93205] = "Thondrax",
		[93654] = "Skul'vrax",
		[93679] = "Gathenak the Subjugator",
		[93686] = "Jinikki the Puncturer",
		[93758] = "Antydas Nightcaller",
		[94414] = "Kiranys Duskwhisper",
		[94485] = "Pollous the Fetid",
		[95123] = "Grelda the Hag",
		[95221] = "Mad Henryk",
		[95318] = "Perrexx",
		[97504] = "Wraithtalon",
		[97517] = "Dreadbog",
		[98241] = "Lyrath Moonfeather",
		[99846] = "Raging Earth",
		[99886] = "Pacified Earth",
		[103785] = "Well-Fed Bear",
		[104523] = "Shalas'aman",
		[106042] = "Kalazzius the Guileful",
		[107924] = "Darkfiend Tormentor",
		[108879] = "Humongris",
		[109125] = "Kathaw the Savage",
		[109281] = "Malisandra",
		[109648] = "Witchdoctor Grgl-Brgl",
		[109692] = "Lytheron",
		[109708] = "Undergrell Ringleader",
		[109990] = "Nylaathria the Forgotten",
		[110342] = "Rabxach",
		[110361] = "Harbinger of Screams",
		[110367] = "Ealdis",
		[110562] = "Bahagar",
		[92040] = "Fenri",
		[97630] = "Soulthirster",
		[109163] = "Captain Dargun",
		[94877] = "Brogrul the Mighty",
		[95204] = "Oubdob da Smasher",
		[95872] = "Skullhat",
		[96072] = "Durguth",
		[96410] = "Majestic Elderhorn",
		[96590] = "Gurbog da Basher",
		[96621] = "Mellok, Son of Torok",
		[97093] = "Shara Felbreath",
		[97102] = "Ram'Pag",
		[97203] = "Tenpak Flametotem",
		[97220] = "Arru",
		[97326] = "Hartli the Snatcher",
		[97345] = "Crawshuk the Hungry",
		[97449] = "Bristlemaul",
		[97593] = "Mynta Talonscreech",
		[97653] = "Taurson",
		[97793] = "Flamescale",
		[97928] = "Tamed Coralback",
		[97933] = "Crab Rider Grmlrml",
		[98024] = "Luggut the Eggeater",
		[98299] = "Bodash the Hoarder",
		[98311] = "Mrrklr",
		[98890] = "Slumber",
		[99846] = "Raging Earth",
		[99886] = "Pacified Earth",
		[99929] = "Flotsam",
		[100230] = "\"Sure-Shot\" Arnie",
		[100231] = "Dargok Thunderuin",
		[100232] = "Ryael Dawndrifter",
		[100302] = "Puck",
		[100303] = "Zenobia",
		[100495] = "Devouring Darkness",
		[101077] = "Sekhan",
		[101649] = "Frostshard",
		[102863] = "Bruiser",
		[104481] = "Ala'washte",
		[104484] = "Olokk the Shipbreaker",
		[104513] = "Defilia",
		[104517] = "Mawat'aki",
		[104524] = "Ormagrogg",
		[107924] = "Darkfiend Tormentor",
		[109498] = "Xaander",
		[109500] = "Jak",
		[109501] = "Darkful",
		[110378] = "Drugon the Frostblood",
		[97057] = "Overseer Brutarg",
		[97058] = "Count Nefarious",
		[97059] = "King Voras",
		[97370] = "General Volroth",
		[96997] = "Kethrazor",
		[97069] = "Wrath-Lord Lekos",
		[99610] = "Garvrulg",
		[99792] = "Elfbane",
		[99899] = "Vicious Whale Shark",
		[100864] = "Cora'kar",
		[102303] = "Lieutenant Strathmar",
		[103183] = "Rok'nash",
		[103203] = "Jetsam",
		[103214] = "Har'kess the Insatiable",
		[103223] = "Hertha Grimdottir",
		[103575] = "Reef Lord Raj'his",
		[103787] = "Baconlisk",
		[103827] = "King Morgalash",
		[103841] = "Shadowquill",
		[104519] = "Colerian",
		[104521] = "Alteria",
		[104522] = "Selenyi",
		[104698] = "Colerian",
		[105547] = "Rauren",
		[105632] = "Broodmother Shu'malis",
		[105728] = "Scythemaster Cil'raman",
		[105739] = "Sanaar",
		[105899] = "Oglok the Furious",
		[106351] = "Artificer Lothaire",
		[106526] = "Lady Rivantas",
		[106532] = "Inquisitor Volitix",
		[107846] = "Pinchshank",
		[109054] = "Shal'an",
		[109943] = "Ana-Mouz",
		[109954] = "Magister Phaedris",
		[110024] = "Mal'Dreth the Corruptor",
		[110321] = "Na'zak the Fiend",
		[110340] = "Myonix",
		[110438] = "Siegemaster Aedrin",
		[110577] = "Oreth the Vile",
		[110656] = "Arcanist Lylandre",
		[110726] = "Cadraeus",
		[110824] = "Tideclaw",
		[110832] = "Gorgroth",
		[110870] = "Apothecary Faldren",
		[110944] = "Guardian Thor'el",
		[111007] = "Randril",
		[111197] = "Anax",
		[111329] = "Matron Hagatha",
		[111649] = "Ambassador D'vwinn",
		[111651] = "Degren",
		[111653] = "Miasu",
		[112497] = "Maia the White",
		[112705] = "Achronos",
		[112756] = "Sorallus",
		[112757] = "Magistrix Vilessa",
		[112758] = "Auditor Esiel",
		[112759] = "Az'jatar",
		[112760] = "Volshax, Breaker of Will",
		[112802] = "Mar'tura",
		[113368] = "Llorian",
		[113694] = "Pashya",
		[101077] = "Sekhan",
		[110486] = "Huk'roth the Huntmaster",
		[108543] = "Dread Captain Thedon",
		[101411] = "Gom Crabbar",
		[111573] = "Kosumoth the Hungering",
		[88779] = "Benjamin Brode",
		[80285] = "Guh",
		[96362] = "Izzy Hollyfizzle",
		[96304] = "Tradurjo Jinglepocket",
		[95471] = "Trader Darakk",
		[79860] = "Zagara",
		[76928] = "Kraank",
		[88228] = "Sergeant Grimjaw",
		[79774] = "Sergeant Grimjaw",
		[91029] = "Rah'thul Moonvale - Dust Trader",
		[91034] = "Calvo Klyne - Fur Trader",
		[91031] = "Nicholas Mitrik - Herb Trader",
		[91033] = "Zeezu - Leather Trader",
		[91030] = "Trixxy Volt - Ore Trader",
		[79813] = "Albert de Hyde",
		[79812] = "Moz'def",
		[79821] = "Yukla Greenshadow",
		[79826] = "Pozzlow",
		[85984] = "Nat Pagle",
		[87302] = "Murg",
		[79828] = "Murg",
		[79832] = "Dorogarr",
		[81981] = "Tarnon",
		[94516] = "Gilda Goldleash",
		[79829] = "Urgra",
		[79864] = "Warra the Weaver",
		[79867] = "Orgek Ironhand",
		[79834] = "Murne Greenhoof",
		[86698] = "Kil'rip",
		[79815] = "Grun'lek",
		[90894] = "Alexi Hackercam - Ore Trader",
		[77383] = "Anders Longstitch",
		[80159] = "Arsenio Zerep",
		[77359] = "Auria Irondreamer",
		[77354] = "Ayada the White",
		[77382] = "Christopher Macdonald",
		[77356] = "Costan Highwall",
		[91025] = "Dorothy \"Two\" - Fur Trader",
		[91020] = "Enchantress Ismaw - Dust Trader",
		[77372] = "Eric Broadoak",
		[91024] = "Jake the Fox - Leather Trader",
		[77379] = "Jonathan Stephens ",
		[85427] = "Maaria",
		[77363] = "Mary Kearie",
		[85344] = "Naron Bloomthistle",
		[77381] = "Raven",
		[91404] = "Samantha Scarlet",
		[88223] = "Sergeant Crowler",
		[78564] = "Sergeant Crowler",
		[94512] = "Tiffy Trapspring",
		[95470] = "Trader Araanda",
		[77365] = "Zaren Hoffle",
		[77377] = "Kristen Stoneforge",		
		[77368] = "Madison Clark",
		[81171] = "Frostdeep Cavedweller",
		[85715] = "Lunarfall Cavedweller",
		[32517] = "Loque'nahak <Mate of Har'koa>",
		[102196] = "Fargo Flintlocke",
		[120266] = "Ilyssia of the Waters",
		[93973] = "Leyweaver Phaxondus",
		[107379] = "Marin Bladewing <Wardens Emissary>",
		[107376] = "Veridis Fallon <Court of Farondis Emissary>",
		[16097] = "Isalien Summonable Read Description",
		[106901] = "Sylvia Hartshorn <Dreamweaver Emissary>",
		[106902] = "Ransa Greyfeather <Highmountain Emissary>",
		[106904] = "Valdemar Stormseeker <Valarjar Emissary>",
		[115736] = "First Arcanist Thalyssra",
		[82459] = "Honest Jim",
		[84243] = "Linny \"The Skinny\" Leadpockets",
		[72896] = "Eternal Kilnmaster",
		[72809] = "Eroded Cliffdweller",
		[72767] = "Jademist Dancer",
		[73162] = "Foreboding Flame",
		[72875] = "Ordon Candlekeeper",
		[72895] = "Burning Berserker",
		[72007] = "Master Kukuru",
	},
	
	["OBJECT_ID_ICONS"] = {
		[186672] = "Interface\\Icons\\INV_Misc_Bag_10",
		[187021] = "Interface\\Icons\\INV_Misc_Basket_05",
		[186667] = "Interface\\Icons\\inv_misc_treasurechest03a",
		[186648] = "Interface\\Icons\\INV_Box_01",
		[181074] = "Interface\\Icons\\Garrison_SilverChest",
		[161495] = "Interface\\Icons\\Battleground_Strongbox_Silver_Alliance",
		[179564] = "Interface\\Icons\\INV_Plate_BlackrockClan_B_01Chest",
		[184465] = "Interface\\Icons\\INV_6_2Raid_Trinket_3b",
		
	};
	["OBJECT_ID_NAMES"] = {
		[220832] = "Sunken Treasure",
		[222685] = "Crane Nest",
		[131979] = "Large Darkwood Chest",
		[141979] = "Ancient Treasure",
		[239828] = "Edge of Reality",
		[239901] = "Voidtalon Egg",
		[227654] = "Bonechewer Spear",
		[227793] = "Aarko's Family Treasure",
		[240622] = "Warden's Spellcase",
		[240616] = "Frozen Supplies",
		[240625] = "High Priestess' Reliquary",
		[240617] = "Lost Sentinel's Pouch",
		[240623] = "Sylvanas' Strongbox",
		[240624] = "Faerie Dragon Nest",
		[34863] = "Bag of Fishing Treasures",
		[46007] = "Bag of Fishing Treasures",
		[44751] = "Hyldnir Spoils",
		[31800] = "Outcast's Cache",
		[179697] = "Arena Treasure Chest",
		[181074] = "Arena Spoils Summonable Read Description",
		[268551] = "Curious Wyrmtongue Cache",
		[161495] = "Secret Safe",
		[179564] = "Gordok Tribute Chest",
		[184465] = "Cache of the Legion",
		[186648] = "Hazlek's Trunk",
		[186667] = "Norkani's Package",
		[186672] = "Kasha's Bag",
		[187021] = "Bakkalzu's Satchel",
		[202080] = "Dart's Nest",
		[202081] = "Takk's Nest",
		[202082] = "Ravasaur Matriarch's Nest",
		[224228] = "Bubbling Cauldron",
		[224750] = "Hanging Satchel",
		[226831] = "Astrologer's Box",
		[226862] = "Giant Moonwillow Cone",
		[232596] = "Ancestral Greataxe",
		[226861] = "Ronokk's Belongings",
		[232586] = "Rovo's Dagger",
		[232621] = "Strange Spore",
		[232592] = "Swamplighter Hive",
		[232587] = "Uzko's Knickknacks",
		[224784] = "Vindicator's Cache",
		[224780] = "Shadowmoon Sacrificial Dagger",
		[224754] = "Waterlogged Chest",
		[226955] = "Arena Master's War Horn",
		[224686] = "Devourer's Gutstone",
		[226983] = "Crag-Leaper's Cache",
		[229640] = "Frozen Frostwolf Axe",
		[230425] = "Gnawed Bone",
		[226967] = "Lagoon Pool (Requires Fishing)",
		[224623] = "Wiggling Egg",
		[239143] = "Glass of Warm Milk",
		[239171] = "Glass of Warm Milk",
		[241692] = "Axe of the Weeping Wolf",
		[241742] = "Book of Zyzzix",
		[241835] = "Bleeding Hollow Mushroom Stash",
		[241605] = "Crystalized Essence of the Elements",
		[241848] = "Dazzling Rod",
		[241600] = "Discarded Helm",
		[241533] = "Forgotten Champion's Blade",
		[241671] = "Forgotten Shard of the Cipher",
		[240580] = "Jewel of Hellfire",
		[241434] = "Lodged Hunting Spear",
		[241565] = "Looted Bleeding Hollow Treasure",
		[241841] = "Looted Mystical Staff",
		[241566] = "Rune Etched Femur",
		[241760] = "Sacrificial Blade",
		[241674] = "Skull of the Mad Chief",
		[241521] = "Snake Charmer's Flute",
		[241599] = "Strange Fruit",
		[240577] = "The Blade of Kra'nak",
		[241847] = "The Commander's Shield",
		[241522] = "The Perfect Blossom",
		[240855] = "Tome of Secrets",
		[240289] = "Weathered Axe",
		[252318] = "The Eye of Aman'thul",
		[272487] = "Oddly-Colored Egg",
		[202741] = "Rich Elementium Giode",
		[244473] = "Thunder Totem Stolen Goods",
		[245479] = "Battered Chest",
		[243773] = "Treasure Chest",
		[243688] = "Treasure Chest",
		[244519] = "Treasure Chest",
		[244628] = "Taurson's Prize",
		[257392] = "Burning Plate of the Worldbreaker",
		[240645] = "Glimmering Treasure Chest",
		[241908] = "Prince's Plunder",
		[254087] = "The Dreadblades",
		[253161] = "Grove Vine",
		[253181] = "Thornstalk",
		[253157] = "Spirit Berries",
		[253179] = "Sunblossom",
		[253118] = "Dreamgrove Blossoms",
		[253176] = "G'Hanir Blossoms",
		[252267] = "Large Plundered Sack",
		[252570] = "Skyhold Chest of Riches",
	};
	
	-- Saved Instance Name => Dungeon Journal Instance Name Converter
	-- If your saves aren't lining up, it's probably because Blizzard
	-- didn't use the same localization for the instance. Sorry.
	["SAVED_TO_DJ_INSTANCES"] = {
		["The Escape from Durnholde"] = "Old Hillsbrad Foothills";
		["Opening of the Dark Portal"] = "The Black Morass";
		["Auchindoun: Auchenai Crypts"] = "Auchenai Crypts";
		["Auchindoun: Mana-Tombs"] = "Mana-Tombs";
		["Auchindoun: Sethekk Halls"] = "Sethekk Halls";
		["Auchindoun: Shadow Labyrinth"] = "Shadow Labyrinth";
		["Coilfang: Serpentshrine Cavern"] = "Serpentshrine Cavern";
		["Hellfire Citadel: Ramparts"] = "Hellfire Ramparts";
		["Hellfire Citadel: The Blood Furnace"] = "The Blood Furnace";
		["Hellfire Citadel: The Shattered Halls"] = "The Shattered Halls";
		["Tempest Keep: The Arcatraz"] = "The Arcatraz";
		["Tempest Keep: The Botanica"] = "The Botanica";
		["Tempest Keep: The Mechanar"] = "The Mechanar";
		["Stormwind Stockade"] = "The Stockade";
		["Ahn'Qiraj Temple"] = "Temple of Ahn'Qiraj";
		["Sunken Temple"] = "The Temple of Atal'hakkar";
		["The Sunwell"] = "Sunwell Plateau";
		["Tempest Keep"] = "The Eye";
	};
	
	-- This is necessary to have because Blizzard does not always have the correct map ID at the time of zone change.
	["ZONE_TEXT_TO_MAP_ID"] = {
		["Onyxia's Lair"] = 718
	};
	
	-- Unobtainable Listing (for fellow 100%s out there)
	["UNOBTAINABLE_ITEM_TEXTURES"] = {
		"Interface\\FriendsFrame\\StatusIcon-DnD", 	-- No Hope
		"Interface\\FriendsFrame\\StatusIcon-Away", -- Little Hope
		"Interface\\FriendsFrame\\StatusIcon-Online",	-- There is Hope
	};
	["UNOBTAINABLE_ITEM_REASONS"] = {
		{1, "|CFFFF0000The source of this item has been removed or was never available to players.|r"}, -- No Hope
		{1, "|CFFFF0000The source of this item has been removed and the item is Bind on Pickup. :(|r"}, -- No Hope
		{2, "|CFFFF0000The source of this item has been removed, but the item is Bind on Equip!|r"}, -- Little Hope
		{2, "|CFFFF0000This item is crafted and only available to the crafter.|r"}, -- There's hope, but you'll need to be this profession.
		{3, "|CFFFF0000This item has a Source ID, but apparently cannot be used for transmog and will likely be unlearnable.|r"},	-- IE: Cookie's Tenderizer
		{3, "|CFFFF0000The source of this item has been removed and the item is a tradeable pet.|r"}, -- There's hope if you can find on AH
		{2, "|CFFFF0000The source of this item has been removed and is only available with the Black Market Auction House.|r"}, -- Little Hope
		{2, "|CFFFF0000This item is purchaseable from a vendor providing you have the associated Feat of Strength for the item.|r"},
		{3, "|CFFFF0000The source of this item has been removed and the item is Bind on Battle.net Account. :(|r"}, -- No Hope
		{2, "|CFFFF0000The source of this item has been removed. You must have completed the Brewfest Riding Rams quest in 2007 to be a purchase from the vendor.|r"},
		{2, "|CFFFF0000The original source of this item has been removed. Now it requires someone with the items from the Dungeon Set 2 questline in order to summon the boss.|r"},
		{2, "|CFFFF0000The original source of this item has been removed. Now it requires someone with the items from the Warlock Dreadsteed quest in order to summon the boss. Items are purchaseable if player has the associated Feat of Strength.|r"},
	};
};

-- Set the fallback file for all translation IDs.
AllTheThings.Locales.Base = { __index = AllTheThings.Locales.enUS };